<?php
/****************************************************************************/
/*!
   	@file		WebNote.php
	@author 	Fanzo.
 	@date 		2007/7/28
*/
/****************************************************************************/

/*
[ データの作成 ]
cmd=new parentid , offset , id , title , doc , icon , handle
->XML <error>エラーコメント</error>

[ データの更新 ]
cmd=update id , title , doc , icon , handle

[ データの削除 ]
cmd=delete id

[ アイテムの移動 ]
cmd=move , id , parentid , offset

[ ツリーデータの獲得 ]
cmd=gettree
<tree>
	<item id="??" icon="??" open="true/false">
		<path>
		</path>
	</item>
	...
</tree>

[ ドキュメントの獲得 ]
cmd=getdocument , id
<document>
	HTMLのドキュメント
</document>

*/

//定数
$db_path	= "./db/webnote.sqlite";
$tablename	= "webnote";

//プログラム定数
 
//初期化
mb_http_output ( 'sjis' );
Header("Content-type: text/xml");

// コマンドの獲得
$command = $_POST['cmd'];

//コマンドごとに分岐
switch( $command )
{
case "new":
	Command_new();
	break;
case "update":
	Command_update();
	break;
case "delete":
	Command_delete();
	break;
case "move":
	Command_move();
	break;
case "gettree":
	Command_gettree();
	break;
case "getdocument":
	Command_getdocument();
	break;
}
//=======================================================================
//!	エラーXMLの出力
//!	@retval			---
//-----------------------------------------------------------------------
function Error
		(
		$message , 
		$db
		)
{
	if( isset( $db ) )
		sqlite_close( $db );
		
	$dom 	= new DomDocument('1.0'); 
	$error = $dom->appendChild( $dom->createElement( 'error' ) ); 
	$error->appendChild( $dom->createTextNode( $message ) ); 
	$dom->formatOutput = true;
	 
 	$output = $dom->saveXML();
	print "$output";

	exit();
}
//=======================================================================
//!	親の獲得
//!	@retval			---
//-----------------------------------------------------------------------
function GetParent
		(
		$db , 
		$id 
		)
{
	global	$tablename;
	
	$code	= "SELECT parent FROM " . $tablename . " WHERE id=\"" . $id . "\"";
	$result = @sqlite_array_query($db, $code );
	if( $result == FALSE )
	{
		Error( "ERROR:GetParent" , $db );
	}
	//childrenの獲得
	$parent;
	foreach ( $result as $entry ) 
	{
		$parent	= $entry[ "parent" ];
	}
	return $parent;
}
//=======================================================================
//!	親の設定
//!	@retval			---
//-----------------------------------------------------------------------
function SetParent
		(
		$db , 
		$id ,
		$parent
		)
{
	global	$tablename;
	
	$result = @sqlite_array_query($db, "UPDATE " . $tablename . " SET " . "parent=\"" . $parent . "\" WHERE id=\"" . $id . "\"" );
	if( $result != FALSE )
	{
		Error( "ERROR:SetParent" , $db );
	}
}
//=======================================================================
//!	子供リストの獲得
//!	@retval			---
//-----------------------------------------------------------------------
function GetChildlist
		(
		$db , 
		$id 
		)
{
	global	$tablename;
	
	$code	= "SELECT children FROM " . $tablename . " WHERE id=\"" . $id . "\"";
	$result = @sqlite_array_query( $db, $code );
	if( $result == FALSE )
	{
		Error( "ERROR:GetChildlist" , $db );
	}
	//childrenの獲得
	$children;
	foreach ( $result as $entry ) 
	{
		$children	= $entry[ "children" ];
	}
	//子供の獲得
	$childlist = split(",", $children );
	
	return $childlist;
}
//=======================================================================
//!	子供の追加
//!	@retval			---
//-----------------------------------------------------------------------
function AddChild
		(
		$db , 
		$parentid , 
		$offset , 
		$child_id 
		)
{
	global	$tablename;

	//ルートの場合は何もしない
//	if( $parentid == "root" )
//		return;
		
	//子供の獲得
	$childlist = GetChildlist( $db , $parentid );
	$num	= count( $childlist );
	if( $offset > $num )
		$offset = $num;

	//挿入する
	if( $offset == $num )
		array_push( $childlist , $child_id );
	else if( $offset == 0 )
		array_unshift( $childlist , $child_id );
	else
	{
		$childlist= array_merge
						( 
						array_slice( $childlist , 0 , $offset ) ,
                      	array( $child_id ),
                      	array_slice( $childlist , $offset, $num - $offset )
						);
	}
	//文字列の作成
	$str	= "";
	for( $off = 0 ; $off < count( $childlist ) ; $off++ )
	{
		if( $childlist[ $off ] == "" )
			continue;
		if( $str != "" )
			$str .=",";
		$str .= $childlist[ $off ];
	}
	//書き換える
	$code	= "UPDATE " . $tablename . " SET children=\"" . $str . "\" WHERE id=\"" . $parentid . "\"";
	$result = sqlite_array_query($db, $code );
	if( $result != FALSE )
	{
		Error( "children update error" , $db );
	}
}
//=======================================================================
//!	子供の削除
//!	@retval			---
//-----------------------------------------------------------------------
function RemoveChild
		(
		$db , 
		$parentid , 
		$child_id 
		)
{
	global	$tablename;

//	if( $parentid == "root" )
//		return;
	//子供の獲得
	$childlist = GetChildlist( $db , $parentid );
	
	//リストの作成
	$new_children	= array();
	foreach ( $childlist as $child ) 
	{
		if( $child_id != $child )
			array_push( $new_children , $child );
	}
	
	//文字列の作成
	$str	= "";
	for( $off = 0 ; $off < count( $new_children ) ; $off++ )
	{
		$str .= $new_children[ $off ];
		if( $off != count( $new_children ) - 1 )
			$str .= ",";
	}
	//書き換える
	$code	= "UPDATE " . $tablename . " SET children=\"" . $str . "\" WHERE id=\"" . $parentid . "\"";
	@sqlite_query( $db, $code );
}
//=======================================================================
//!	tableの初期化
//!	@retval			---
//-----------------------------------------------------------------------
function InitTable
		(
		$db
		)
{
	global	$tablename;
	
	//table作成
	$result = @sqlite_query($db, "CREATE TABLE " . $tablename . " (id TEXT, title TEXT, document TEXT, parent TEXT , children TEXT , icon INTEGER , open INTEGER)");
	if( $result != FALSE )
	{
		$code = "INSERT INTO " . $tablename . " (id,title,document,parent,children,icon,open) VALUES (\"root\" , \"root\" , \"\" , \"\" , \"\" , 0 , 1 )";
		@sqlite_query($db, $code) or Error( "new item error." , $db );
	}
}
//=======================================================================
//!	new
//!	@retval			---
//-----------------------------------------------------------------------
function Command_new()
{
	global	$tablename;
	
	// パラメータの獲得
	if( isset( $_POST[ "parentid" ] ) == false )
		Error( "parentid parameter is not exist" );
	if( isset( $_POST[ "offset" ] ) == false )
		Error( "offset parameter is not exist" );
	if( isset( $_POST[ "id" ] ) == false )
		Error( "id parameter is not exist" );
	if( isset( $_POST[ "title" ] ) == false )
		Error( "title parameter is not exist" );
	if( isset( $_POST[ "document" ] ) == false )
		Error( "document parameter is not exist" );
	if( isset( $_POST[ "icon" ] ) == false )
		Error( "icon parameter is not exist" );
	if( isset( $_POST[ "open" ] ) == false )
		Error( "open parameter is not exist" );
		
	//データベースの処理
	global	$db_path;
	$db = sqlite_open( $db_path ) or Error( "db open error." );
	
	//table作成
	InitTable( $db );

	//id検索
	$result = @sqlite_array_query($db, "SELECT id from " . $tablename . " where id=\"" . $_POST[ "id" ] . "\"" );
	if( $result != FALSE )
	{
		Error( "id already exist." , $db );
	}
	
	// link
	AddChild( $db , $_POST[ "parentid" ] , $_POST[ "offset" ] , $_POST[ "id" ] );

	// new
	$code = "INSERT INTO " . $tablename . " (id,title,document,parent,children,icon,open) VALUES (\"" . $_POST[ "id" ] . "\",\"" . $_POST[ "title" ] . "\",\"" . $_POST[ "document" ] . "\",\"" . $_POST[ "parentid" ] . "\",\"\"," . $_POST[ "icon" ] . "," . $_POST[ "open" ] . ")";
	@sqlite_query($db, $code) or Error( "new item error." , $db );

	sqlite_close( $db );
}
//=======================================================================
//!	update
//!	@retval			---
//-----------------------------------------------------------------------
function Command_update()
{
	global	$tablename;
	
	// パラメータの獲得
	if( isset( $_POST[ "id" ] ) == false )
		Error( "syntax error" );
		
	//データベースの処理
	global	$db_path;
	$db = sqlite_open( $db_path ) or Error( "db open error." );
	
	//更新
	$code	= "UPDATE " . $tablename . " SET";
	$code	.= " id=\"" . $_POST[ "id" ] . "\"";
	
	if( isset( $_POST[ "title" ] ) == true )
		$code	.= ",title=\"" . $_POST[ "title" ] . "\"";
	if( isset( $_POST[ "document" ] ) == true )
		$code	.= ",document=\"" . $_POST[ "document" ] . "\"";
	if( isset( $_POST[ "icon" ] ) == true )
		$code	.= ",icon=" . $_POST[ "icon" ];
	if( isset( $_POST[ "open" ] ) == true )
		$code	.= ",open=" . $_POST[ "open" ];
	$code .= " WHERE id=\"" . $_POST[ "id" ] . "\"";
	
	//作成
	@sqlite_query($db, $code ) or Error( "update id is not found." , $db );

	// close
	sqlite_close( $db );
}
//=======================================================================
//!	delete
//!	@retval			---
//-----------------------------------------------------------------------
function Delete
		(
		$db , 
		$id
		)
{
	global	$tablename;
	
	//子供の削除
	$childlist = GetChildlist( $db , $id );
	foreach ( $childlist as $child ) 
	{
		if( $child != "" )
		{
			Delete( $db , $child );
		}
	}
	//親の子リスと空削除
	RemoveChild( $db , GetParent( $db , $id ) , $id );
	
	//削除
	$code 	= "DELETE FROM " . $tablename . " WHERE id=\"" . $id . "\"";
	@sqlite_query($db, $code ) or Error( "delete id is not found." , $db );
}

//=======================================================================
//!	delete
//!	@retval			---
//-----------------------------------------------------------------------
function Command_delete()
{
	global	$tablename;
	
	// パラメータの獲得
	if( isset( $_POST[ "id" ] ) == false )
		Error( "id parameter is not exist." );
		
	//データベースの処理
	global	$db_path;
	$db = sqlite_open( $db_path ) or Error( "db open error." );
	
	//削除
	Delete( $db , $_POST[ "id" ] );

	// close
	sqlite_close( $db );
}
//=======================================================================
//!	move
//!	@retval			---
//-----------------------------------------------------------------------
function Command_move()
{
	global	$tablename;
	
	// パラメータの獲得
	if( isset( $_POST[ "id" ] ) == false )
		Error( "id parameter is not exist." );
	if( isset( $_POST[ "parentid" ] ) == false )
		Error( "parentid parameter is not exist." );
	if( isset( $_POST[ "offset" ] ) == false )
		Error( "offset parameter is not exist." );
		
	//データベースの処理
	global	$db_path;
	$db = sqlite_open( $db_path ) or Error( "db open error." );
	
	//移動
	RemoveChild( $db , GetParent( $db , $_POST[ "id" ] ) , $_POST[ "id" ] );
	AddChild( $db , $_POST[ "parentid" ] , $_POST[ "offset" ] , $_POST[ "id" ] );
	SetParent( $db , $_POST[ "id" ] , $_POST[ "parentid" ] );

	// close
	sqlite_close( $db );
}
//=======================================================================
//!	ツリーアイテムの獲得
//!	@retval			---
//-----------------------------------------------------------------------
function GetTreeItem
		(
		$db , 
		$id , 
		&$title , 
		&$icon , 
		&$open 
		)
{
	global	$tablename;
	
	$code	 = "SELECT title,icon,open FROM " . $tablename . " WHERE id=\"" . $id . "\"";
	$result = @sqlite_array_query( $db, $code );
	if( $result == FALSE )
		Error( "ERROR:GetTreeItem" , $db );

	// アイテムの作成
	foreach ( $result as $entry ) 
	{
		$title	= stripslashes( $entry[ "title" ] );
		$icon	= stripslashes( $entry[ "icon" ] );
		$open	= stripslashes( $entry[ "open" ] );
	}
}
//=======================================================================
//!	gettree
//!	@retval			---
//-----------------------------------------------------------------------
function GetTree
		(
		$db , 
		$id , 
		$dom , 
		$element
		)
{
	GetTreeItem( $db , $id , $title , $icon , $open );
	$item = $element->appendChild( $dom->createElement( 'item' ) ); 
	$item->setAttribute( "id", stripslashes( $id ) ); 
	$item->setAttribute( "icon", $icon ); 
	$item->setAttribute( "open", $open ); 
	$item->setAttribute( "title", $title ); 

	$children	= GetChildlist( $db , $id );
	foreach ( $children as $child ) 
	{
		if( $child != "" )		
			GetTree( $db , $child , $dom , $item );
	}
}
//=======================================================================
//!	gettree
//!	@retval			---
//-----------------------------------------------------------------------
function Command_gettree()
{
/*
<tree>
	<item id="??" icon="??" open="true/false">
		<path>
		</path>
	</item>
	...
</tree>
*/
	global	$tablename;

	//データベースの処理
	global	$db_path;
	$db = sqlite_open( $db_path ) or Error( "db open error." );

	//table作成
	InitTable( $db );
	// domの作成
	$dom 	= new DomDocument('1.0'); 
	$tree = $dom->appendChild( $dom->createElement( 'tree' ) ); 
	
	//獲得
	$children = GetChildlist( $db , "root" );
	foreach ( $children as $id ) 
	{
		if( $id != "" )
			GetTree( $db , $id , $dom , $tree );
	}

	// close
	sqlite_close( $db );

	//出力
	$dom->formatOutput = true;
 	$output = $dom->saveXML();
	print "$output";
}	
//=======================================================================
//!	getdocument
//!	@retval			---
//-----------------------------------------------------------------------
function Command_getdocument()
{
/*
<document>
	HTMLのドキュメント
</document>
*/
	global	$tablename;

	//データベースの処理
	global	$db_path;
	$db = sqlite_open( $db_path ) or Error( "db open error." );

	// domの作成
//	$dom 	= new DomDocument('1.0'); 
//	$document = $dom->appendChild( $dom->createElement( 'document' ) ); 
	
	//獲得
	$result = @sqlite_array_query($db, "SELECT document from " . $tablename . " WHERE id=\"" . $_POST[ "id" ] . "\"" );
	if( $result == FALSE )
		Error( "id not exist." , $db );

	if( count( $result ) != 1 )
		Error( "many id exist." );
	
	//釣りかする
//	$document->appendChild( $dom->createTextNode( stripslashes( $result[ 0 ][ "document" ] ) ) );

	// close
//	sqlite_close( $db );

	//出力
//	$dom->formatOutput = true;
 ///	$output = $dom->saveXML();
//	print "$output";
$output = stripslashes( $result[ 0 ][ "document" ] );
	print $output;
}	

?> 