﻿/****************************************************************************
"ButtonView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function ButtonView
		(
		pull_imgpath , 
		over_imgpath , 
		push_imagepath , 
		tooltip , 
		callback , 
		type
		)
{
	var		m_Type				= type == null ? "push" : type;
	var		m_State				= false;
	var		m_Images			= new Array( pull_imgpath , over_imgpath , push_imagepath );
	var		m_EventCallback		= callback;
	var		m_Tooltip			= tooltip;
	var		m_Inner				= false;
	
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "ButtonView_" + GetUniqueId();
	var		m_Doc				= null;
	
// イベント関数
/*==================================================
onfocus
		return   ---
---------------------------------------------------*/
this.OnFocus = function
		(
		args
		)
{
	alert( "focus" );
}
/*==================================================
mouseenter
		return   ---
---------------------------------------------------*/
this.OnMouseOver = function
		(
		args
		)
{
	m_Inner	= true;
	var img = m_Doc.getElementById( m_Id + "_img" );
	
	if( m_Type == "push" )
	{
		img.setAttribute( "src" , m_Images[ 1 ] );
	}
	else if( m_Type == "toggle" )
	{
		if( m_State == false )
			img.setAttribute( "src" , m_Images[ 1 ] );
		else 
			img.setAttribute( "src" , m_Images[ 2 ] );
	}
	else if( m_Type == "onepush" )
	{
		if( m_State == false )
			img.setAttribute( "src" , m_Images[ 1 ] );
		else 
			img.setAttribute( "src" , m_Images[ 2 ] );
	}
}
/*==================================================
mouseout
		return   ---
---------------------------------------------------*/
this.OnMouseOut = function
		(
		args
		)
{
	m_Inner	= false;
	var img = m_Doc.getElementById( m_Id + "_img" );
	if( m_Type == "push" )
	{
		img.setAttribute( "src" , m_Images[ 0 ] );
	}
	else if( m_Type == "toggle" )
	{
		if( m_State == false )
			img.setAttribute( "src" , m_Images[ 0 ] );
	}
	else if( m_Type == "onepush" )
	{
		if( m_State == false )
			img.setAttribute( "src" , m_Images[ 0 ] );
	}
}
/*==================================================
mousedown
		return   ---
---------------------------------------------------*/
this.OnMouseDown = function
		(
		args
		)
{
	var img = m_Doc.getElementById( m_Id + "_img" );
	if( m_Type == "push" )
	{
		img.setAttribute( "src" , m_Images[ 2 ] );
	}
	else if( m_Type == "toggle" )
	{
		if( m_State == false )
			img.setAttribute( "src" , m_Images[ 2 ] );
		else
			img.setAttribute( "src" , m_Images[ 2 ] );
	}
	else if( m_Type == "onepush" )
	{
		if( m_State == false )
			img.setAttribute( "src" , m_Images[ 2 ] );
		else
			img.setAttribute( "src" , m_Images[ 2 ] );
	}
}
/*==================================================
mouseup
		return   ---
---------------------------------------------------*/
this.OnMouseUp = function
		(
		args
		)
{
	var img = m_Doc.getElementById( m_Id + "_img" );
	var	ck = 0;
	if( m_Type == "push" )
	{
		img.setAttribute( "src" , m_Images[ 1 ] );
		ck = 1;
	}
	else if( m_Type == "toggle" )
	{
		if( m_State == false )
			img.setAttribute( "src" , m_Images[ 2 ] );
		else
			img.setAttribute( "src" , m_Images[ 1 ] );
		ck = 1;
		m_State	= m_State == false ? true : false;
	}
	else if( m_Type == "onepush" )
	{
		img.setAttribute( "src" , m_Images[ 2 ] );
		if( m_State == false )
			ck = 1;
		m_State	= true;
	}	
	if( ck == 1 && m_EventCallback != null && m_Inner == true )
	{
		m_EventCallback();
	}
}
// private function define
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		root			//!< [in] root dom
		)
{
	var	img	= root.appendChild( m_Doc.createElement( "img" ) );
	{
		img.setAttribute( "id" , m_Id + "_img" );
		img.setAttribute( "src" , m_Images[ 0 ] );
		img.onmouseover 	= new CallbackAdapt( m_Self.OnMouseOver ).exec;
		img.onmouseout	 	= new CallbackAdapt( m_Self.OnMouseOut ).exec;
		img.onmousedown	 	= new CallbackAdapt( m_Self.OnMouseDown ).exec;
		img.onmouseup	 	= new CallbackAdapt( m_Self.OnMouseUp ).exec;
//		img.onselectstart	= new CallbackAdapt( m_Self.OnSelectStart ).exec;
		img.onfocus			= new CallbackAdapt( m_Self.OnFocus ).exec;
		if( m_Tooltip != null )
			img.title = m_Tooltip;
		img.style.cursor='pointer';
	}
}

// public functions define
//=======================================================================
//!	ツールチップの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetTooltip = function
		(
		tooltip_string
		)
{
	m_Tooltip	= tooltip_string;
}
//=======================================================================
//!	eventコールバック関数の設定。
//!	@retval			---
//-----------------------------------------------------------------------
this.SetEventCallback = function
		(
		callback_obj		//!< [in] このオブジェクトのOnButtonEvent関数が呼ばれる
		)
{
	m_EventCallback = callback_obj;
}
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc		= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}
//=======================================================================
//!	状態の獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.GetState = function()
{
	return m_State;
}
//=======================================================================
//!	状態の設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetState = function
		(
		state	
		)
{
	m_State	= state;

	var img = m_Doc.getElementById( m_Id + "_img" );
	if( m_Type == "push" )
	{
	}
	else if( m_Type == "toggle" )
	{
		if( m_State == false )
			img.setAttribute( "src" , m_Images[ 0 ] );
		else
			img.setAttribute( "src" , m_Images[ 2 ] );
	}
	else if( m_Type == "onepush" )
	{
		if( m_State == false )
			img.setAttribute( "src" , m_Images[ 0 ] );
		else
			img.setAttribute( "src" , m_Images[ 2 ] );
	}
}
}
