﻿/****************************************************************************
"ColorSelectView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function ColorSelectView()
{
	
// private function define
//=======================================================================
//!	sample color
//!	@retval			---
//-----------------------------------------------------------------------
this.OnTableOver = function()
{
	var		color = ColorToStr( m_ColorTbl.GetSelectColor() );
	{
		var		sample = m_Doc.getElementById( m_Id + "_sample" );
		sample.style.backgroundColor	= color;
	}
	{
		var		disp = m_Doc.getElementById( m_Id + "_text" );
		if( disp.hasChildNodes() )
			disp.removeChild( disp.lastChild );
		disp.appendChild( m_Doc.createTextNode( color.toUpperCase() ) );
	}
}
//=======================================================================
//!	sample color
//!	@retval			---
//-----------------------------------------------------------------------
this.OnTableClick = function()
{
	if( m_Self.onselect != null )
	{
		m_Self.onselect();
	}
}

	// イベント
	this.onselect				= null;
	
	// 変数
	var		m_ColorTbl			= new ColorTableView();
	{
		m_ColorTbl.onover 			= this.OnTableOver;
		m_ColorTbl.onclick 			= this.OnTableClick;
	}
	
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "ColorSelectView_" + GetUniqueId();
	var		m_Doc	= null;

// private function define
//=======================================================================
//!	sample color
//!	@retval			---
//-----------------------------------------------------------------------
function SampleColor
		(
		parent			//!< [in] root dom
		)
{
	var	table	= parent.appendChild( m_Doc.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
		table.width			= "100%";
	}
	var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
	var	tr		= tbody.appendChild( m_Doc.createElement( "tr" ) );
	{
		tr.setAttribute( "height" , "50" );
		var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
		{
			td.setAttribute( "width" , "50px" );
			td.setAttribute( "align" , "center" );
			var		frame	= td.appendChild( m_Doc.createElement( "table" ) );
			{
				frame.setAttribute( "id" , m_Id + "_sample" );
				frame.style.border = "1px solid #000000";
				frame.setAttribute( "width" , "30px" );
				frame.setAttribute( "height" , "30px" );
				frame.style.backgroundColor	= "#FF0000";
			}
			var		ttbody	= frame.appendChild( m_Doc.createElement( "tbody" ) );
			var		ttr	= ttbody.appendChild( m_Doc.createElement( "tr" ) );
			var		ttd	= ttr.appendChild( m_Doc.createElement( "td" ) );
		}
	}
	{
		var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
		{
			td.setAttribute( "id" , m_Id + "_text" );
			var	text= td.appendChild( m_Doc.createTextNode( "#000000" ) );
		}
	}
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent			//!< [in] root dom
		)
{
	var	table	= parent.appendChild( m_Doc.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
	}
	var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );

	{
		var	tr		= tbody.appendChild( m_Doc.createElement( "tr" ) );
		{
			var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
			{
				SampleColor( td );
			}
		}
	}
	{
		var	tr		= tbody.appendChild( m_Doc.createElement( "tr" ) );
		{
			var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
			td.appendChild( m_ColorTbl.CreateDOM( m_Doc ) );
		}
	}
}

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc		= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}
//=======================================================================
//!	選択色の獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.GetSelectColor = function()
{
	return m_ColorTbl.GetSelectColor();
}

}


/****************************************************************************
"ColorSelectMenu" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function ColorSelectMenu
		(
		lt_path , 
		ct_path , 
		rt_path , 
		lc_path , 
		cc_path , 
		rc_path , 
		lb_path , 
		cb_path , 
		rb_path , 
		sh_folder 
		)
{
// イベント
//=======================================================================
//!	色選択
//!	@retval			---
//-----------------------------------------------------------------------
this.OnSelectColor = function()
{
	m_Menu.HideMenu();
	if( m_Self.onselectcolor != null )
		m_Self.onselectcolor();
}
//=======================================================================
//!	隠す
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMenuHide = function()
{
	if( m_Self.onmenuhide != null )
		m_Self.onmenuhide();
}
	// イベント
	this.onselectcolor			= null;
	this.onmenuhide				= null;
	
	// 変数
	var		m_ColorSelectView	= new ColorSelectView();
	{
		m_ColorSelectView.onselect	= this.OnSelectColor;
	}
	var		m_Menu				= new MenuView
			(
			lt_path , 
			ct_path , 
			rt_path , 
			lc_path , 
			cc_path , 
			rc_path , 
			lb_path , 
			cb_path , 
			rb_path , 
			sh_folder , 
			m_ColorSelectView
			);
	{
		m_Menu.onhide	= this.OnMenuHide;
	}
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "ColorSelectMenu_" + GetUniqueId();

// private function define

// public functions define
//=======================================================================
//!	menuの開始
//!	@retval			---
//-----------------------------------------------------------------------
this.ShowMenu = function
		(
		x ,		//!< [in] 表示位置 
		y		//!< [in] 表示位置
		)
{
	m_Menu.ShowMenu( x , y );
}
//=======================================================================
//!	選択色の獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.GetSelectColor = function()
{
	return m_ColorSelectView.GetSelectColor();
}

}


/****************************************************************************
"ColorSelectButton" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function ColorSelectButton
		(
		lt_path , 
		ct_path , 
		rt_path , 
		lc_path , 
		cc_path , 
		rc_path , 
		lb_path , 
		cb_path , 
		rb_path , 
		sd_path , 
		pull_imgpath , 
		over_imgpath , 
		push_imagepath 
		)
{
// イベント
//=======================================================================
//!	ボタンを押した
//!	@retval			---
//-----------------------------------------------------------------------
this.OnButtonPress = function()
{
	var		button = m_Doc.getElementById( m_Id );
	if( button == null )
		return;
		
	pos = GetElementPos( m_Doc , button );
	m_ColorSelectMenu.ShowMenu( pos.x , pos.y + button.offsetHeight );	
}
//=======================================================================
//!	色選択
//!	@retval			---
//-----------------------------------------------------------------------
this.OnSelectColor = function()
{
	if( m_Self.onselectcolor != null )
		m_Self.onselectcolor();
}
//=======================================================================
//!	メニューを閉じる
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMenuHide	 = function()
{
	m_Button.SetState( false );
}

	// イベント
	this.onselectcolor			= null;
	
	// 変数
	var		m_ColorSelectMenu	= new ColorSelectMenu
			(
			lt_path , 
			ct_path , 
			rt_path , 
			lc_path , 
			cc_path , 
			rc_path , 
			lb_path , 
			cb_path , 
			rb_path , 
			sd_path
			);
	{
		m_ColorSelectMenu.onselectcolor	= this.OnSelectColor;
		m_ColorSelectMenu.onmenuhide	= this.OnMenuHide;
	}
	var		m_Button		= new ButtonView
			(
			pull_imgpath , 
			over_imgpath , 
			push_imagepath , 
			"色の選択" , 
			this.OnButtonPress , 
			"onepush"
			);
	
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "ColorSelectButton_" + GetUniqueId();
	var		m_Doc				= null;
	
// private function define

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc	= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	root.appendChild( m_Button.CreateDOM( m_Doc ) );
	
	return root;
}
//=======================================================================
//!	選択色の獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.GetSelectColor = function()
{
	return m_ColorSelectMenu.GetSelectColor();
}

}
