﻿/****************************************************************************
"ColorTableView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function ColorTableView()
{
	// イベント
	this.onover		= null;
	this.onclick	= null;
	
	// メンバ変数
	var		m_SelectX = 0;
	var		m_SelectY = 0;
	var		m_Self				= this;
	var 	m_Id				= "ColorTableView_" + GetUniqueId();
	var		m_W					= 12;
	var		m_H					= 12;
//	var		m_SelectColor		= "#0000CC";
	var		m_ColorTbl			= new Array
			(
			0x000000 , 
			0x333333 , 
			0x666666 , 
			0x999999 , 
			0xcccccc , 
			0xffffff , 
			0xff0000 , 
			0x00ff00 , 
			0x0000ff , 
			0xffff00 , 
			0x00ffff , 
			0xff00ff
			);
// イベント
/*==================================================
mouseenter
		return   ---
---------------------------------------------------*/
this.OnMouseOver = function
		(
		args
		)
{
	sx = args[ 0 ];
	sy = args[ 1 ];
	if( sx == m_SelectX && sy == m_SelectY )
		return;
		
	var		old_it = document.getElementById( m_Id + "index_" + m_SelectX + "_" + m_SelectY );
	var		it = document.getElementById( m_Id + "index_" + sx + "_" + sy );
	if( it == null )
		return;
		
	it.style.border	= "1px solid " + ColorToStr( GetSelectColor( sx , sy ) );
	old_it.style.border	= "1px solid " + ColorToStr( GetColor( m_SelectX , m_SelectY ) );
	
	//更新
	m_SelectX	= sx;
	m_SelectY	= sy;
	
	// イベント
	if( m_Self.onover != null )
		m_Self.onover();
}
/*==================================================
mouseenter
		return   ---
---------------------------------------------------*/
this.OnClick = function
		(
		args
		)
{
	// イベント
	if( m_Self.onclick != null )
		m_Self.onclick();
}
// private function define
//=======================================================================
//!	get color
//!	@retval			---
//-----------------------------------------------------------------------
function GetColor
		(
		x , 
		y
		)
{
	var		color;
	if( x == 0 )
	{
		color	= m_ColorTbl[ y ];
	}
	else
	{
		x--;
	
		index = Math.floor( y / 6 ) * 3 + Math.floor( x / 6 );
		sc 	= 0x000000 + index * 0x330000;	
		tx	= x % 6;
		ty	= y % 6;
		color	= sc + tx * 0x003300 + ty * 0x000033;
	}
	return color;
}
//=======================================================================
//!	get select color
//!	@retval			---
//-----------------------------------------------------------------------
function GetSelectColor
		(
		x , 
		y
		)
{
	var	color = GetColor( x , y );
	return 0xffffff - color;
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent			//!< [in] root dom
		)
{
	var	table	= parent.appendChild( document.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
		table.setAttribute( "width" , ( m_W * 6 * 3 + 1 ) );
		table.setAttribute( "height" , ( m_H * 12 ) );
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );

	for( var y = 0 ; y < 12 ; y++ )
	{
		var	tr		= tbody.appendChild( document.createElement( "tr" ) );
		
		for( var x = 0 ; x < 6 * 3 + 1 ; x++ )
		{
			var	td		= tr.appendChild( document.createElement( "td" ) );
			{
				var	tt	= td.appendChild( document.createElement( "table" ) );
				{
					tt.onmouseover 	= new CallbackAdapt( m_Self.OnMouseOver , x , y ).exec;
					tt.onmousedown 	= new CallbackAdapt( m_Self.OnClick , x , y ).exec;
					tt.setAttribute( "id" , m_Id + "index_" + x + "_" + y );
				
					var		color = ColorToStr( GetColor( x , y ) );
					tt.setAttribute( "width" , m_W );
					tt.setAttribute( "height" , m_H );
					if( x == m_SelectX && y == m_SelectY )
						tt.style.border	= "1px solid " + ColorToStr( GetSelectColor( x , y ) );
					else
					{
						tt.style.border	= "1px solid " + color;
					}
					tt.style.backgroundColor	= color;
				}
				var	ttbody	= tt.appendChild( document.createElement( "tbody" ) );
				var	ttr		= ttbody.appendChild( document.createElement( "tr" ) );
				var	ttd		= ttr.appendChild( document.createElement( "td" ) );
			}
		}
	}
}
// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function()
{
	var	root	= document.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}
//=======================================================================
//!	get select color
//!	@retval			---
//-----------------------------------------------------------------------
this.GetSelectColor = function()
{
	return GetColor( m_SelectX , m_SelectY );
}

}
