﻿/****************************************************************************
"ComboView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function ComboView
		(
		tooltip
		)
{
	this.onchange				= null;

	var		m_Items				= new Array( 0 );
	var		m_Values			= new Array( 0 );
	var		m_Tooltip			= tooltip;
	
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "ComboView_" + GetUniqueId();

// event functions define
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.OnChange = function
		(
		args
		)
{
	if( m_Self.onchange != null )
	{
		m_Self.onchange();
	}
}
// private function define
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent			//!< [in] root dom
		)
{
	var	sel	= parent.appendChild( document.createElement( "select" ) );
	{
		sel.setAttribute( "id" , m_Id + "_combo" );
	}
	if( m_Tooltip != null )
		sel.title = m_Tooltip;
	sel.onchange = new CallbackAdapt( m_Self.OnChange ).exec;
	var		off , num = m_Items.length;
	for( off = 0 ; off < num ; off++ )
	{
		var	op	= sel.appendChild( document.createElement( "option" ) );
		{
			op.value	= m_Values[ off ];
			op.appendChild( document.createTextNode( m_Items[ off ] ) );
		}		
	}
}

// public functions define
//=======================================================================
//!	add item
//!	@retval			---
//-----------------------------------------------------------------------
this.AddItem = function
		(
		name , 
		value
		)
{
	m_Items.push( name );
	m_Values.push( value );
}
//=======================================================================
//!	add items
//!	@retval			---
//-----------------------------------------------------------------------
this.AddItems = function
		(
		names , 
		values
		)
{
	var		off , num = names.length;
	for( off = 0 ; off < num ; off++ )
	{
		m_Items.push( names[ off ] );
		m_Values.push( values[ off ] );
	}
}
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function()
{
	var	root	= document.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}
//=======================================================================
//! 選択の獲得	
//!	@retval			---
//-----------------------------------------------------------------------
this.GetSelect = function()
{
	var		sel = document.getElementById( m_Id + "_combo" );
	if( sel == null )
		return null;
	return sel.value;
}
//=======================================================================
//! 選択の設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetSelect = function
		(
		val
		)
{
	var		sel = document.getElementById( m_Id + "_combo" );
	if( sel == null )
		return;
	sel.value	= val;
}

}
