﻿/****************************************************************************
"TitleView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function TitleView
		(
		title , 
		close_button
		)
{
	var		m_Title			= title;
	var		m_CloseButton	= close_button;
	
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "TitleView_" + GetUniqueId();

// private function define
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		root			//!< [in] root dom
		)
{
	var	table	= root.appendChild( document.createElement( "table" ) );
	{
		table.setAttribute( "width" , "100%" );
		table.setAttribute( "height" , "100%" );
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );

	{
		var	tr		= tbody.appendChild( document.createElement( "tr" ) );
		{
			var	td		= tr.appendChild( document.createElement( "td" ) );
			td.style.textAlign = "left";
			td.appendChild( document.createTextNode( m_Title ) );
		}
		if( m_CloseButton != null && m_CloseButton.CreateDOM != null )
		{
			var	td		= tr.appendChild( document.createElement( "td" ) );
			td.style.textAlign = "right";
			td.appendChild( m_CloseButton.CreateDOM( document ) );
		}
	}
}

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function()
{
	var	root	= document.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}

}

/****************************************************************************
"DialogView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function DialogView
		(
		lt_path , 
		ct_path , 
		rt_path , 
		lc_path , 
		cc_path , 
		rc_path , 
		lb_path , 
		cb_path , 
		rb_path , 
		sd_folder
		)
{
	var		m_ImgPath 			= Array
			( 
			lt_path , 
			ct_path , 
			rt_path , 
			lc_path , 
			cc_path , 
			rc_path , 
			lb_path , 
			cb_path , 
			rb_path 
			);	
	var		m_Callback			= null;
	var		m_HeaderView		= null;
	var		m_View				= null;
	var		m_Shadow			= new ShadowView( sd_folder , null );
	
	// event object
	var		m_ResizeEvent		= null;
	
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "DialogView_" + GetUniqueId();

// イベント関数
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.OnWindowResize = function
		(
		args
		)
{
	var		div = document.getElementById( m_Id );
	if( div == null )
		return;

	div.style.width		= document.body.clientWidth;//"100%";
	div.style.height	= document.body.clientHeight;//"100%";
}
// private function define
//=======================================================================
//!	hide back
//!	@retval			---
//-----------------------------------------------------------------------
function HideBack()
{
	var	div	= document.body.appendChild( document.createElement( "div" ) );
	{
		div.setAttribute( "id" , m_Id );
		div.style.position	= "absolute";
		div.style.left		= 0;
		div.style.top		= 0;
		div.style.width		= "100%";//document.body.clientWidth;//"100%";
		div.style.height	= "100%";//document.body.clientHeight;//"100%";
		div.style.backgroundColor	= "#333333";
		if( div.style.opacity != null )
			div.style.opacity	= "0.2";
		else
			div.style.filter = 'alpha(opacity=20)';
	}
	return div;
}
//=======================================================================
//!	show dialgo frame
//!	@retval			---
//-----------------------------------------------------------------------
function GetDialgCenter()
{
	var		obj;
	var	div	= document.body.appendChild( document.createElement( "div" ) );
	{
		div.setAttribute( "id" , m_Id + "_Dialog" );
		div.style.position	= "absolute";
		div.style.left		= 0;
		div.style.top		= 0;
		div.style.width		= "100%";
		div.style.height		= "100%";
	}
	var	table	= div.appendChild( document.createElement( "table" ) );
	{
		table.setAttribute( "width" , "100%" );
		table.setAttribute( "height" , "100%" );
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );

	for( y = 0 ; y < 3 ; y++ )
	{
		var	tr		= tbody.appendChild( document.createElement( "tr" ) );
		for( x = 0 ; x < 3 ; x++ )
		{
			var	td		= tr.appendChild( document.createElement( "td" ) );
			if( x == 1 && y == 1 )
			{
				td.setAttribute( "align" , "center" );
				obj = td;
			}
		}
	}
	return obj;
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDom_line
		(
		tbody , 			//!< [in] parent dom
		image_id , 
		content
		)
{
/*
<table cellspacing="0" cellpadding="0" width="100%" border="0">
<tbody>
  <tr>
    <td width="1" background="../img/open_0_0.png" ><img src="../img/open_0_0.png"></td>
    <td background="../img/open_0_1.png">content または <img src="../img/open_0_1.png"></td>
    <td width="1" background="../img/open_0_2.png"><img src="../img/open_0_2.png"></td>
  </tr>
</tbody>  
</table>
*/
/*
	var	table	= parent.appendChild( document.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
//		table.setAttribute( "width" , "100%" );
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );
*/
	var	tr		= tbody.appendChild( document.createElement( "tr" ) );
	{
		var	td		= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1" );
			td.setAttribute( "background" , m_ImgPath[ image_id ] );
		}
		var img		= td.appendChild( document.createElement( "img" ) );
		{
			img.setAttribute( "src" , m_ImgPath[ image_id ] );
		}
	}
	{
		var	td		= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "background" , m_ImgPath[ image_id + 1 ] );
		}
		if( content != null && content.CreateDOM != null )
			td.appendChild( content.CreateDOM( document ) );
		else
		{
			var img		= td.appendChild( document.createElement( "img" ) );
			{
				img.setAttribute( "src" , m_ImgPath[ image_id + 1 ] );
			}
		}			
	}
	{
		var	td		= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1" );
			td.setAttribute( "background" , m_ImgPath[ image_id + 2 ] );
		}
		var img		= td.appendChild( document.createElement( "img" ) );
		{
			img.setAttribute( "src" , m_ImgPath[ image_id + 2 ] );
		}
	}
}
//=======================================================================
//!	show dialgo frame
//!	@retval			---
//-----------------------------------------------------------------------
function DialogFrame
		(
		parent
		)
{
	var	table	= document.createElement( "table" );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
//		table.setAttribute( "width" , "100%" );
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );
	CreateDom_line( tbody , 0 , m_HeaderView );
	CreateDom_line( tbody , 3 , m_View );
	CreateDom_line( tbody , 6 , null );
	
	parent.appendChild( m_Shadow.GenDOM( table ) );
}
//=======================================================================
//!	show dialog
//!	@retval			---
//-----------------------------------------------------------------------
function ShowDialog()
{
	// リサイズのイベントのコールバック
//	m_ResizeEvent	= new CallbackAdapt( m_Self.OnWindowResize );
/*	
	if( window.attachEvent != null )
	{
		alert( "bb" );
		window.attachEvent( 'resize',m_ResizeEvent.exec );
	}
*/
//	window.addEventListener( 'resize',m_ResizeEvent.exec, true);

	var		back_div = HideBack();
	var		center	= GetDialgCenter();
	DialogFrame( center );
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		root			//!< [in] root dom
		)
{
}

// public functions define
//=======================================================================
//!	Viewの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetTitleView = function
		(
		view
		)
{
	m_HeaderView	= view;
}
//=======================================================================
//!	titleの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetTitle = function
		(
		title , 
		close_button
		)
{
	m_HeaderView = new TitleView( title , close_button );
}
//=======================================================================
//!	Viewの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetView = function
		(
		view
		)
{
	m_View	= view;
}
//=======================================================================
//!	callbackの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetCallback = function
		(
		callback
		)
{
	m_Callback	= callback;
}
//=======================================================================
//!	表示する
//!	@retval			---
//-----------------------------------------------------------------------
this.Dialog = function()
{
	ShowDialog();
}
//=======================================================================
//!	hide dialog
//!	@retval			---
//-----------------------------------------------------------------------
this.EndDialog = function()
{
	{
	var		dlg = document.getElementById( m_Id + "_Dialog" );
	if( dlg == null )
		return;
	dlg.parentNode.removeChild( dlg );
	}
	{
	var		dlg = document.getElementById( m_Id );
	if( dlg == null )
		return;
	dlg.parentNode.removeChild( dlg );
	}
}

}
