﻿/****************************************************************************/
/*!
   	@file		ExpandListView.js
 	
	@author 	Fanzo
 	@date 		2007/7/8
*/
/****************************************************************************/

/****************************************************************************
"ExpandListView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function ExpandListView
		(
		table_stylename , 		//!< [in] ヘッダーのスタイル名
		header_stylename , 		//!< [in] ヘッダーのスタイル名
		open_image_path , 		//!< [in] オープンイメージのパス
		close_image_path		//!< [in] クローズイメージパス
		)
{
	// メンバクラス
	function Content()
	{
		this.m_Name		= null;
		this.m_Content	= null;
		this.m_Open		= true;
	}
	// メンバ変数
	this.m_TableStyleName	= table_stylename;
	this.m_HeaderStyleName	= header_stylename;
	this.m_OpenImagePath		= open_image_path;
	this.m_CloseImagePath	= close_image_path;
	var		m_Self				= this;
	var 	m_Contents 			= new Array( 0 );
	var 	m_Id				= "ContetnsView_" + GetUniqueId();

// private function define
//=======================================================================
//!	ヘッダーを設定する
//!	@retval			DOMオブジェクト
//-----------------------------------------------------------------------
function HeaderDOM
		(
		content_off		//!< [in] コンテンツ位置
		)
{
	var	root	= document.createElement( "span" );
	var	table	= root.appendChild( document.createElement( "table" ) );
	{
		table.className = m_Self.m_TableStyleName;
		table.setAttribute( "width" , "100%" );
//		table.setAttribute( "height" , "100px" );
//		table.setAttribute( "border" , "1" );
		table.setAttribute( "cellspacing" , "0" );
//		table.setAttribute( "cellpadding" , "0" );
//		table.setAttribute( "bgcolor" , "#000066" );
//		code += '<table width="100%" border="0" bgcolor="#000066" cellspacing="0" cellpadding="0"><tr><td><font color="#FFFFFF"><A class="lnk" href="javascript:m_Test.test()" ><img src="file:///J|/ProgramWEB/images/ListOpen.png" width="9" height="9">' + " " + this.m_Items[ i ].m_Name + '</A></font></td></tr></table>';	
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );
	var	tr 		= tbody.appendChild( document.createElement( "tr" ) );
	var	td		= tr.appendChild( document.createElement( "td" ) );
	var a	= td.appendChild( document.createElement( "a" ) );
	{
		a.className = m_Self.m_HeaderStyleName;
		a.onclick = new CallbackAdapt( m_Self.OnHeaderClick , content_off ).exec;
		a.setAttribute( "href" , "javascript:(function(){})();" );
	}

	var	img = a.appendChild( document.createElement( "img" ) );
	{
		if( m_Contents[ content_off ].m_Open == true )
			img.setAttribute( "src" , m_Self.m_OpenImagePath );
		else
			img.setAttribute( "src" , m_Self.m_CloseImagePath );
		img.setAttribute( "border" , "0" );
	}
	var	text= a.appendChild( document.createTextNode( " " + m_Contents[ content_off ].m_Name ) );
	
	// contentの追加
	if( m_Contents[ content_off ].m_Open == true && m_Contents[ content_off ].m_Content != null )
	{
		root.appendChild( m_Contents[ content_off ].m_Content.CreateDOM() );
	}
		
	return root;
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		root			//!< [in] root dom
		)
{
	// コンテンツのヘッダーの追加
	var		content_off;
	for( content_off = 0 ; content_off < m_Contents.length ; content_off++ )
	{
		root.appendChild( HeaderDOM( content_off ) );
	}
}
// event functions define
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.OnHeaderClick = function
		(
		args
		)
{
	var		click_off = args[ 0 ];
	if( m_Contents[ click_off ].m_Open == true ) 
		m_Contents[ click_off ].m_Open = false;
	else
		m_Contents[ click_off ].m_Open = true;
	
	// root以下を更新する	
	var		root = document.getElementById( m_Id );
	RemoveChildAll( root );
	if( root != null )
		CreateDomUnderRoot( root );
}

// functions define	
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.AddContent = function
		(
		content_name , 
		content_object , 
		content_open
		)
{
	var		content = new Content();
	content.m_Name 		= content_name;
	content.m_Content	= content_object;
	content.m_Open		= content_open;
	m_Contents.push( content );
}
/*==================================================
DOMの獲得
		return   ---
---------------------------------------------------*/
this.CreateDOM = function()
{
	var	root	= document.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}
//=======================================================================
//!	SaveCookie
//!	@retval			---
//-----------------------------------------------------------------------
this.SaveCookie = function
		(
		name , 
		day
		)
{
	var		off , num = m_Contents.length;
	for( off = 0 ; off < num ; off++ )
	{
		// oepn状態のセーブ
		var		tag = name + "_" + off;
		if( m_Contents[ off ].m_Open == true )
			SetCookie( tag , "true" , day );
		else
			SetCookie( tag , "false" , day );
		
		// コンテンツのセーブ
		if( m_Contents[ off ].m_Content != null && m_Contents[ off ].m_Content.SaveCookie != null )
		{
			m_Contents[ off ].m_Content.SaveCookie( tag + "_content" , day );
		} 
	}
}
//=======================================================================
//!	LoadCookie
//!	@retval			---
//-----------------------------------------------------------------------
this.LoadCookie = function
		(
		name
		)
{
	var		off , num = m_Contents.length;
	for( off = 0 ; off < num ; off++ )
	{
		// oepn状態のセーブ
		var		tag = name + "_" + off;
		var		val = GetCookie( tag );
		if( val != null )
		{
			if( val == "true" )
				m_Contents[ off ].m_Open = true;
			else if( val == "false" )
				m_Contents[ off ].m_Open = false;
		}
		
		// コンテンツのロード
		if( m_Contents[ off ].m_Content != null && m_Contents[ off ].m_Content.LoadCookie != null )
		{
			m_Contents[ off ].m_Content.LoadCookie( tag + "_content" );
		} 
	}
}
}


