﻿/****************************************************************************
"HtmlEditorView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function HtmlEditorView()
{
	this.onupdate				= null;
	
	// メンバ変数
	var		m_Self				= this;
	var		m_Width				= null;
	var		m_Height			= null;
	var 	m_Id				= "HtmlEditorView_" + GetUniqueId();
	var		m_Doc				= null;
	var		m_Show				= true;
	
// イベント関数
//=======================================================================
//!	key
//!	@retval			---
//-----------------------------------------------------------------------
this.OnKeyDown = function
		(
		args
		)
{
	e = m_Doc.getElementById( m_Id + "_iFrame" ).contentWindow.event;
	k = e.keyCode;
	m = e.shiftKey;
	
	if( k == 13 )
	{
		doc	= GetIFrameDocument();
		b = doc.createElement( "br" );
		doc.execCommand( "InsertMarquee" , false , "marquee_code" );
		doc.getElementById("marquee_code").parentNode.replaceChild(b,doc.getElementById("marquee_code"));
		return false;
	}
 }
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.OnMouseOver = function
		(
		args
		)
{
	var	doc = GetIFrameDocument();
//	if( doc == null )
//		return;
//	if( doc.designMode == false )
//		return;
	doc.designMode = "on";
	
	if( m_Doc.all == null )
	{
		iframe = m_Doc.getElementById( m_Id + "_iFrame" );
		if( iframe != null && iframe.contentWindow != null )
		{
			m_Doc.getElementById( m_Id + "_iFrame" ).contentWindow.addEventListener('keyup',new CallbackAdapt( m_Self.OnKeyUp ).exec, true);
			m_Doc.getElementById( m_Id + "_iFrame" ).contentWindow.addEventListener('click',new CallbackAdapt( m_Self.OnClick ).exec, true);
			m_Doc.getElementById( m_Id + "_iFrame" ).contentWindow.addEventListener('mousedown',new CallbackAdapt( m_Self.OnMouseDown ).exec, true);
		}
	}
	else
	{
		GetIFrameDocument().onkeyup = new CallbackAdapt( m_Self.OnKeyUp ).exec;
		GetIFrameDocument().onclick = new CallbackAdapt( m_Self.OnClick ).exec;
		GetIFrameDocument().onmousedown = new CallbackAdapt( m_Self.OnMouseDown ).exec;
//		GetIFrameDocument().onkeydown = new CallbackAdapt( m_Self.OnKeyDown ).exec;
	}
}
//=======================================================================
//!	mousedown
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMouseDown = function
		(
		args
		)
{
	OnBodyClick_menuview();
}
//=======================================================================
//!	click
//!	@retval			---
//-----------------------------------------------------------------------
this.OnClick = function
		(
		args
		)
{
	if( m_Self.onupdate != null )
	{
		m_Self.onupdate();
	}
}
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.OnKeyUp = function
		(
		args
		)
{
	if( m_Self.onupdate != null )
	{
		m_Self.onupdate();
	}
//	alert( "aa" );
}
// private function define
//=======================================================================
//!	get iframe object
//!	@retval			---
//-----------------------------------------------------------------------
function GetIFrameDocument()
{
	var		doc = null;
	if( m_Doc.all )
	{
		var iframe = m_Doc.getElementById( m_Id + "_iFrame" );
		doc = iframe.contentWindow.document;
	}
	else
	{
		doc = m_Doc.getElementById( m_Id + "_iFrame" ).contentDocument;
	}
	return doc;
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		root			//!< [in] root dom
		)
{
	var	iframe	= root.appendChild( m_Doc.createElement( "iframe" ) );
	{
		iframe.setAttribute( "id" , m_Id + "_iFrame" );
		iframe.setAttribute( "width" , "100%" );
		iframe.setAttribute( "height" , "100%" );
		iframe.style.visibility = m_Show == true ? "visible" : "hidden";
		iframe.setAttribute( "border" , 0 );
		iframe.setAttribute( "frameborder" , 0 );
		iframe.onmouseover 	= new CallbackAdapt( m_Self.OnMouseOver ).exec;
	}
}


// public functions define
//=======================================================================
//!	show
//!	@retval			---
//-----------------------------------------------------------------------
this.Show = function
		(
		sw
		)
{
	m_Show	= sw;
	if( m_Doc != null )
	{
		var	iframe	= m_Doc.getElementById( m_Id + "_iFrame" );
		if( iframe != null )
			iframe.style.visibility = m_Show == true ? "visible" : "hidden";
	}
}
//=======================================================================
//!	サイズの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetSize = function
		(
		width , 
		height
		)
{
	m_Width	= width;
	m_Height= height;
}
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc		= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}
//=======================================================================
//!	bold
//!	@retval			---
//-----------------------------------------------------------------------
this.Bold = function()
{
	GetIFrameDocument().execCommand( "bold" , false , null );
}
//=======================================================================
//! is bold	
//!	@retval			---
//-----------------------------------------------------------------------
this.IsBold = function()
{
	return GetIFrameDocument().queryCommandState( "bold" );
}
//=======================================================================
//!	italic
//!	@retval			---
//-----------------------------------------------------------------------
this.Italic = function()
{
	GetIFrameDocument().execCommand( "italic" , false , null );
}
//=======================================================================
//! is italic	
//!	@retval			---
//-----------------------------------------------------------------------
this.IsItalic = function()
{
	return GetIFrameDocument().queryCommandState( "italic" );
}
//=======================================================================
//!	underline
//!	@retval			---
//-----------------------------------------------------------------------
this.Underline = function
		(
		sw
		)
{
	GetIFrameDocument().execCommand( "underline" , false , null );
}
//=======================================================================
//! is underline	
//!	@retval			---
//-----------------------------------------------------------------------
this.IsUnderline = function()
{
	return GetIFrameDocument().queryCommandState( "underline" );
}
//=======================================================================
//!	copy
//!	@retval			---
//-----------------------------------------------------------------------
this.Copy = function()
{
	GetIFrameDocument().execCommand( "copy" , false , null );
}
//=======================================================================
//!	cut
//!	@retval			---
//-----------------------------------------------------------------------
this.Cut = function()
{
	GetIFrameDocument().execCommand( "cut" , false , null );
}
//=======================================================================
//!	paste
//!	@retval			---
//-----------------------------------------------------------------------
this.Paste = function()
{
	GetIFrameDocument().execCommand( "paste" , false , null );
}
//=======================================================================
//!	undo
//!	@retval			---
//-----------------------------------------------------------------------
this.Undo = function()
{
	GetIFrameDocument().execCommand( "undo" , false , null );
}
//=======================================================================
//!	redo
//!	@retval			---
//-----------------------------------------------------------------------
this.Redo = function()
{
	GetIFrameDocument().execCommand( "redo" , false , null );
}
//=======================================================================
//!	left align
//!	@retval			---
//-----------------------------------------------------------------------
this.LeftAlign = function()
{
	GetIFrameDocument().execCommand( "justifyLeft" , false , null );
}
//=======================================================================
//! is left align	
//!	@retval			---
//-----------------------------------------------------------------------
this.IsLeftAlign = function()
{
	return GetIFrameDocument().queryCommandState( "justifyLeft" );
}
//=======================================================================
//!	center align
//!	@retval			---
//-----------------------------------------------------------------------
this.CenterAlign = function()
{
	GetIFrameDocument().execCommand( "justifyCenter" , false , null );
}
//=======================================================================
//! is left align	
//!	@retval			---
//-----------------------------------------------------------------------
this.IsCenterAlign = function()
{
	return GetIFrameDocument().queryCommandState( "justifyCenter" );
}
//=======================================================================
//!	right align
//!	@retval			---
//-----------------------------------------------------------------------
this.RightAlign = function()
{
	GetIFrameDocument().execCommand( "justifyRight" , false , null );
}
//=======================================================================
//! is right align	
//!	@retval			---
//-----------------------------------------------------------------------
this.IsRightAlign = function()
{
	return GetIFrameDocument().queryCommandState( "justifyRight" );
}
//=======================================================================
//!	indent
//!	@retval			---
//-----------------------------------------------------------------------
this.Indent = function()
{
	GetIFrameDocument().execCommand( "indent" , false , null );
}
//=======================================================================
//!	outdent
//!	@retval			---
//-----------------------------------------------------------------------
this.Outdent = function()
{
	GetIFrameDocument().execCommand( "outdent" , false , null );
}
//=======================================================================
//!	textcolor
//!	@retval			---
//-----------------------------------------------------------------------
this.TextColor = function
		(
		color
		)
{
	m_Doc.getElementById( m_Id + "_iFrame" ).focus();
	GetIFrameDocument().execCommand( "forecolor" , false , color );
}
//=======================================================================
//!	fontsize
//!	@retval			---
//-----------------------------------------------------------------------
this.FontSize = function
		(
		size		//!< [in] 0-7
		)
{
	GetIFrameDocument().execCommand( "fontsize" , false , size );
}
//=======================================================================
//!	get fontsize
//!	@retval			---
//-----------------------------------------------------------------------
this.GetFontSize = function()
{
	return GetIFrameDocument().queryCommandValue( "fontsize" );
}
//=======================================================================
//!	fontname
//!	@retval			---
//-----------------------------------------------------------------------
this.FontName = function
		(
		facename
		)
{
	GetIFrameDocument().execCommand( "fontname", false, facename );
}
//=======================================================================
//!	get fontsize
//!	@retval			---
//-----------------------------------------------------------------------
this.GetFontName = function()
{
	return GetIFrameDocument().queryCommandValue( "fontname" );
}
//=======================================================================
//!	get html
//!	@retval			---
//-----------------------------------------------------------------------
this.GetHtml = function()
{
	return GetIFrameDocument().body.innerHTML;
}
//=======================================================================
//!	set html
//!	@retval			---
//-----------------------------------------------------------------------
this.SetHtml = function
		(
		html
		)
{
	GetIFrameDocument().body.innerHTML	= html;
}
}
