﻿
var	YES_BUTTON 		= 1;
var	NO_BUTTON 		= 2;
var	CANCEL_BUTTON 	= 4;
var	CAUTION_ICON	= 8;
var ERROR_ICON		= 16;

/****************************************************************************
"MessageDlg" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function MessageDlg
		(
		imgpath , 
		sd_folder
		)
{
//=======================================================================
//!	indent
//!	@retval			---
//-----------------------------------------------------------------------
this.OnYes		= function()
{
	m_Dialog.EndDialog();
	if( m_Self.ondialogend != null )
		m_Self.ondialogend( YES_BUTTON );
}
//=======================================================================
//!	indent
//!	@retval			---
//-----------------------------------------------------------------------
this.OnNo		= function()
{
	m_Dialog.EndDialog();
	if( m_Self.ondialogend != null )
		m_Self.ondialogend( NO_BUTTON );
}
//=======================================================================
//!	indent
//!	@retval			---
//-----------------------------------------------------------------------
this.OnCancel		= function()
{
	m_Dialog.EndDialog();
	if( m_Self.ondialogend != null )
		m_Self.ondialogend( CANCEL_BUTTON );
}
	// イベント
	this.ondialogend	= null;
	
	// ダイアログ
	var		m_ImgPath	= imgpath;
	var		m_Dialog	= new DialogView
			(
			imgpath + "/dlg_0_0.png" , 
			imgpath + "/dlg_0_1.png" , 
			imgpath + "/dlg_0_2.png" , 
			imgpath + "/dlg_1_0.png" , 
			imgpath + "/dlg_1_1.png" , 
			imgpath + "/dlg_1_2.png" , 
			imgpath + "/dlg_2_0.png" , 
			imgpath + "/dlg_2_1.png" , 
			imgpath + "/dlg_2_2.png" , 
			sd_folder
			);
	var		m_Yes		= new ButtonView
			(
			imgpath + "/yes_0.png" , 
			imgpath + "/yes_1.png" , 
			imgpath + "/yes_2.png" , 
			null , 
			this.OnYes , 
			"push"
			);		
	var		m_No		= new ButtonView
			(
			imgpath + "/no_0.png" , 
			imgpath + "/no_1.png" , 
			imgpath + "/no_2.png" , 
			null , 
			this.OnNo , 
			"push"
			);		
	var		m_Cancel		= new ButtonView
			(
			imgpath + "/cancel_0.png" , 
			imgpath + "/cancel_1.png" , 
			imgpath + "/cancel_2.png" , 
			null , 
			this.OnCancel , 
			"push"
			);		

	// メンバ変数
	var		m_Message			= "";
	var		m_State				= 0;
	var		m_Self				= this;
	var 	m_Id				= "MessageDlg_" + GetUniqueId();
	var		m_Doc				= null;

// private function define
//=======================================================================
//! get icon path	
//!	@retval			---
//-----------------------------------------------------------------------
function GetIconPath()
{
	if( ( m_State & CAUTION_ICON ) != 0 )
		return m_ImgPath + "/icon_caution.png";
	else if( ( m_State & ERROR_ICON ) != 0 )
		return m_ImgPath + "/icon_error.png";
	return null;
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		root			//!< [in] root dom
		)
{
	var	div	= root.appendChild( m_Doc.createElement( "div" ) );
	div.setAttribute( "align" , "center" );
	{
		var	table	= div.appendChild( m_Doc.createElement( "table" ) );
		{
//			table.setAttribute( "width" , "100%" );
			table.border	= 0;
					
			var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
			{
				var	tr 		= tbody.appendChild( m_Doc.createElement( "tr" ) );
				{
					imgpath	= GetIconPath();
					if( imgpath != null )
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						{
							td.width = "1";
							var		img = td.appendChild( m_Doc.createElement( "img" ) );
							{
								img.setAttribute( "src" , imgpath );
							}
						}
					}
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						var	ddiv	= td.appendChild( m_Doc.createElement( "div" ) );
						ddiv.style.whiteSpace = "nowrap";
						var		ary = m_Message.split("\n");
						for( var i = 0 ; i < ary.length ; i++ )
						{
							ddiv.appendChild( m_Doc.createTextNode( ary[ i ] ) );
							ddiv.appendChild( m_Doc.createElement( "wbr" ) );
						}
					}
				}
			}
		}
	}
	div.appendChild( m_Doc.createElement("br") );
	// buttons
	{
		var	table	= div.appendChild( m_Doc.createElement( "table" ) );
		{
			table.border	= 0;
					
			var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
			{
				var	tr 		= tbody.appendChild( m_Doc.createElement( "tr" ) );
				{
					// yes
					if( m_State & YES_BUTTON )
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						td.appendChild( m_Yes.CreateDOM( m_Doc ) );
					}
					// no
					if( m_State & NO_BUTTON )
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						td.appendChild( m_No.CreateDOM( m_Doc ) );
					}
					// cancel
					if( m_State & CANCEL_BUTTON )
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						td.appendChild( m_Cancel.CreateDOM( m_Doc ) );
					}
				}
			}
		}
	}
}

// public functions define
//=======================================================================
//!	MessageDlg
//!	@retval			---
//-----------------------------------------------------------------------
this.MessageDlg = function
		(
		title , 
		message ,
		state
		)
{
	m_Message	= message;
	m_State		= state;
	
	m_Dialog.SetView( m_Self );
	m_Dialog.SetTitleView( new HtmlView( '<font color="#FFFFFF" >' + title + '</font>' ) );
	m_Dialog.Dialog();
}
//=======================================================================
//!	EndMessageDlg
//!	@retval			---
//-----------------------------------------------------------------------
this.EndMessageDlg = function()
{
	m_Dialog.EndDialog();
}
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc	= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}

}
