﻿/****************************************************************************
"RichEditor" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function RichEditor
		(
		imgpath
		)
{
// event function define
//=======================================================================
//!	OnUpdateState
//!	@retval			---
//-----------------------------------------------------------------------
this.OnUpdateState	= function()
{
	m_Bold.SetState( true == m_EditorView.IsBold() ? 1 : 0 );
	m_Italic.SetState( true == m_EditorView.IsItalic() ? 1 : 0 );
	m_Under.SetState( true == m_EditorView.IsUnderline() ? 1 : 0 );
	m_Left.SetState( true == m_EditorView.IsLeftAlign() ? 1 : 0 );
	m_Center.SetState( true == m_EditorView.IsCenterAlign() ? 1 : 0 );
	m_Right.SetState( true == m_EditorView.IsRightAlign() ? 1 : 0 );
	m_Sizelist.SetSelect( m_EditorView.GetFontSize() );
//	alert( m_EditorView.GetFontSize() );
}
//=======================================================================
//!	fontsize
//!	@retval			---
//-----------------------------------------------------------------------
this.OnFontsize		= function()
{
	var	size = m_Sizelist.GetSelect();
	m_EditorView.FontSize( size == -1 ? null : size );
}
//=======================================================================
//!	bold
//!	@retval			---
//-----------------------------------------------------------------------
this.OnBold		= function()
{
	m_EditorView.Bold( true );
}
//=======================================================================
//!	italic
//!	@retval			---
//-----------------------------------------------------------------------
this.OnItalic		= function()
{
	m_EditorView.Italic( true );
}
//=======================================================================
//!	under
//!	@retval			---
//-----------------------------------------------------------------------
this.OnUnder		= function()
{
	m_EditorView.Underline( true );
}
//=======================================================================
//!	copy
//!	@retval			---
//-----------------------------------------------------------------------
this.OnCopy		= function()
{
	m_EditorView.Copy();
}
//=======================================================================
//!	cut
//!	@retval			---
//-----------------------------------------------------------------------
this.OnCut		= function()
{
	m_EditorView.Cut();
}
//=======================================================================
//!	paste
//!	@retval			---
//-----------------------------------------------------------------------
this.OnPaste		= function()
{
	m_EditorView.Paste();
}
//=======================================================================
//!	undo
//!	@retval			---
//-----------------------------------------------------------------------
this.OnUndo		= function()
{
	m_EditorView.Undo();
}
//=======================================================================
//!	redo
//!	@retval			---
//-----------------------------------------------------------------------
this.OnRedo		= function()
{
	m_EditorView.Redo();
}
//=======================================================================
//!	left
//!	@retval			---
//-----------------------------------------------------------------------
this.OnLeft		= function()
{
	m_EditorView.LeftAlign();
	m_Center.SetState( 0 );
	m_Right.SetState( 0 );
}
//=======================================================================
//!	center
//!	@retval			---
//-----------------------------------------------------------------------
this.OnCenter		= function()
{
	m_EditorView.CenterAlign();
	m_Left.SetState( 0 );
	m_Right.SetState( 0 );
}
//=======================================================================
//!	right
//!	@retval			---
//-----------------------------------------------------------------------
this.OnRight		= function()
{
	m_EditorView.RightAlign();
	m_Left.SetState( 0 );
	m_Center.SetState( 0 );
}
//=======================================================================
//!	indent
//!	@retval			---
//-----------------------------------------------------------------------
this.OnIndent		= function()
{
	m_EditorView.Indent();
}
//=======================================================================
//!	outdent
//!	@retval			---
//-----------------------------------------------------------------------
this.OnOutdent		= function()
{
	m_EditorView.Outdent();
}
//=======================================================================
//!	textcolor
//!	@retval			---
//-----------------------------------------------------------------------
this.OnTextColor		= function()
{
	m_EditorView.TextColor( ColorToStr( m_TextColor.GetSelectColor() ) );
}

	// image path
	var		m_ImgPath = imgpath;

	// parts	
	var		m_Pad		= new ImgView( imgpath + "/pad.png" );
	var		m_Separator	= new ImgView( imgpath + "/separator.png" );

	// editor
	var		m_EditorView= new HtmlEditorView();
	m_EditorView.SetSize( "100%" , "100%" );
	m_EditorView.onupdate	= this.OnUpdateState;
	
	// fontlist
	var		m_Fontlist	= new ComboView( "文字のフェイスの設定" );
	
	// sizelist
	var		m_Sizelist	= new ComboView( "文字のサイズの設定" );
	m_Sizelist.AddItems( new Array( "8pt" , "10pt" , "12pt" , "14pt" , "18pt" , "24pt" , "36pt" ) , new Array( 1 ,2 , 3 , 4 , 5 , 6 , 7 ) );
 	m_Sizelist.onchange = this.OnFontsize; 
 	
	// bold
	var		m_Bold = new ButtonView( imgpath + "/bold_pull.png" , imgpath + "/bold_over.png" , imgpath + "/bold_push.png" , "ボールドの設定" , this.OnBold , "toggle" );

	// italic
	var		m_Italic = new ButtonView( imgpath + "/italic_pull.png" , imgpath + "/italic_over.png" , imgpath + "/italic_push.png" , "イタリックの設定" , this.OnItalic , "toggle" );

	// under
	var		m_Under = new ButtonView( imgpath + "/under_pull.png" , imgpath + "/under_over.png" , imgpath + "/under_push.png" , "アンダーバーの設定" , this.OnUnder , "toggle" );

	// copy
	var		m_Copy = new ButtonView( imgpath + "/copy_pull.png" , imgpath + "/copy_over.png" , imgpath + "/copy_push.png" , "テキストのコピー" , this.OnCopy );

	// cut
	var		m_Cut = new ButtonView( imgpath + "/cut_pull.png" , imgpath + "/cut_over.png" , imgpath + "/cut_push.png" , "テキストのカット" , this.OnCut );

	// paste
	var		m_Paste = new ButtonView( imgpath + "/paste_pull.png" , imgpath + "/paste_over.png" , imgpath + "/paste_push.png" , "貼り付け" , this.OnPaste );

	// undo
	var		m_Undo = new ButtonView( imgpath + "/undo_pull.png" , imgpath + "/undo_over.png" , imgpath + "/undo_push.png" , "元に戻す" , this.OnUndo );

	// redo
	var		m_Redo = new ButtonView( imgpath + "/redo_pull.png" , imgpath + "/redo_over.png" , imgpath + "/redo_push.png" , "やり直す" , this.OnRedo );

	// left
	var		m_Left = new ButtonView( imgpath + "/left_pull.png" , imgpath + "/left_over.png" , imgpath + "/left_push.png" , "左揃え" , this.OnLeft , "onepush" );

	// center
	var		m_Center = new ButtonView( imgpath + "/center_pull.png" , imgpath + "/center_over.png" , imgpath + "/center_push.png" , "中央揃え" , this.OnCenter , "onepush" );

	// right
	var		m_Right = new ButtonView( imgpath + "/right_pull.png" , imgpath + "/right_over.png" , imgpath + "/right_push.png" , "右揃え" , this.OnRight , "onepush" );

	// ind_off
	var		m_IndOff = new ButtonView( imgpath + "/ind_off_pull.png" , imgpath + "/ind_off_over.png" , imgpath + "/ind_off_push.png" , "インデント解除" , this.OnOutdent );

	// ind_on
	var		m_IndOn = new ButtonView( imgpath + "/ind_on_pull.png" , imgpath + "/ind_on_over.png" , imgpath + "/ind_on_push.png" , "インデント" , this.OnIndent );

	// textcolor
//	var		m_TextColor = new ButtonView( imgpath + "/textcolor_pull.png" , imgpath + "/textcolor_over.png" , imgpath + "/textcolor_push.png" , "テキストの色" , this.OnTextColor );
	var		m_TextColor = new ColorSelectButton
			( 
			imgpath + "/menu/menu_0_0.png" , 
			imgpath + "/menu/menu_0_1.png" , 
			imgpath + "/menu/menu_0_2.png" , 
			imgpath + "/menu/menu_1_0.png" , 
			imgpath + "/menu/menu_1_1.png" , 
			imgpath + "/menu/menu_1_2.png" , 
			imgpath + "/menu/menu_2_0.png" , 
			imgpath + "/menu/menu_2_1.png" , 
			imgpath + "/menu/menu_2_2.png" , 
			imgpath + "/shadow" , 
			imgpath + "/textcolor_pull.png" , 
			imgpath + "/textcolor_over.png" , 
			imgpath + "/textcolor_push.png" 
			);
	{
		m_TextColor.onselectcolor = this.OnTextColor;
	}

	// toolbar
	var		m_Toolbar			= new ToolbarView
			(
			imgpath + "/toolbar_0_0.png" , 
			imgpath + "/toolbar_0_1.png" , 
			imgpath + "/toolbar_0_2.png" , 
			imgpath + "/toolbar_1_0.png" , 
			imgpath + "/toolbar_1_1.png" , 
			imgpath + "/toolbar_1_2.png" , 
			imgpath + "/toolbar_2_0.png" , 
			imgpath + "/toolbar_2_1.png" , 
			imgpath + "/toolbar_2_2.png"
			);
	m_Toolbar.AddViews
		(
		new Array
			(
			m_Fontlist ,
			m_Pad , 
			m_Sizelist , 
			m_Separator , 
			m_Bold , 
			m_Italic , 
			m_Under , 
			m_Separator ,
			m_Copy , 
			m_Cut , 
			m_Paste , 
			m_Separator , 
			m_Undo , 
			m_Redo , 
			m_Separator  , 
			m_Left , 
			m_Center , 
			m_Right , 
			m_Separator , 
			m_IndOff , 
			m_IndOn , 
			m_Separator , 
			m_TextColor
			)
		);
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "RichEditor_" + GetUniqueId();

// private function define
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent			//!< [in] root dom
		)
{
	var	table	= parent.appendChild( document.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
		table.setAttribute( "width" , "100%" );
		table.setAttribute( "height" , "100%" );
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );
	// toolbar
	{
		var	tr		= tbody.appendChild( document.createElement( "tr" ) );
		var	td		= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "height" , "1" );
		}
		td.appendChild( m_Toolbar.CreateDOM() );
	}
	// editor
	{
		var	tr		= tbody.appendChild( document.createElement( "tr" ) );
		var	td		= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "height" , "100%" );
		}
		td.appendChild( m_EditorView.CreateDOM() );
	}
}

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function()
{
	var	root	= document.createElement( "span" );
	root.setAttribute( "id" , m_Id );
		root.setAttribute( "width" , "100%" );
		root.setAttribute( "height" , "100%" );

	CreateDomUnderRoot( root );
	return root;
}

}
