﻿/****************************************************************************/
/*!
   	@file		TreePanel.js
 	
	@author 	Fanzo
 	@date 		2007/7/8
*/
/****************************************************************************/


/****************************************************************************
"TreePanelItem" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function TreePanelItem()
{
	this.m_Html			= null;
	this.m_UUID			= GenUniqueString();
	this.m_Title		= null;
	this.m_IconId		= 0;
	this.m_Open			= false;

	this.m_Parent		= null;
	this.m_Children		= new Array( 0 );
	this.m_Id			= "TreePanelItem_" + GetUniqueId();
	var		m_Self		= this;

	var		m_Tab_num	= 0;
	var		m_TV		= null;
	var		m_Doc		= null;
	
	var		m_SelectFrameColor	= "#000080";
	var		m_SelectBackColor	= "#FFD38E";
	
// event functions define
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.OnHandleClick = function
		(
		args
		)
{
	m_Self.m_Open = m_Self.m_Open == true ? false : true;
	var		root = m_Doc.getElementById( m_Self.m_Id );
	
	RemoveChildAll( root );
	if( root == null )
		alert( "aa" );
	GetItemDOM_root( root , m_Tab_num , m_TV );
	
	if( m_TV != null && m_TV.onexpand != null )
		m_TV.onexpand( m_Self );
}
/*==================================================
アイテムを選択
		return   ---
---------------------------------------------------*/
this.OnItemClick = function
		(
		args
		)
{
	if( m_Self == m_TV.m_Select )
		return;
	if( m_TV.m_Select != null )
	{
		m_TV.m_Select.SetSelect( false );
		
		// event
		if( m_TV.onpreselect != null )
		{
			var	html = m_TV.onpreselect( m_TV.m_Select );
			if( html != null )
				m_TV.m_Select.m_Html = html;
		}
	}
	//処理	
	m_TV.m_Select = m_Self;
	m_Self.SetSelect( true );
	
	// event
	if( m_TV.onselect != null )
	{
		m_TV.onselect( m_Self );
	}	
}
// private function define
//=======================================================================
//!	td imgの追加
//!	@retval			---
//-----------------------------------------------------------------------
function AppendTD_IMG
		(
		parent , 
		img_path
		)
{
	var	td = parent.appendChild( m_Doc.createElement( "td" ) );
	{
//			td.setAttribute( "width" , "1%" );
	}
	var	img = td.appendChild( m_Doc.createElement( "img" ) );
	{
		img.setAttribute( "src" , img_path );
	}
	return img;
}
// private functions define
//=======================================================================
//!	root以下のアイテムの獲得
//!	@retval			---
//-----------------------------------------------------------------------
function GetItemDOM_root 
		(
		root ,  
		tab_num ,  			//!< [in] タブ数
		tv 
		)
{
	//保存
	m_Tab_num	= tab_num;
	m_TV		= tv;

	//アイテムのDOMの作成
	var	table	= root.appendChild( m_Doc.createElement( "table" ) );
	{
		table.cellspacing	= 0;
		table.cellpadding	= 0;
		table.border		= 0;
//		table.setAttribute( "cellspacing" , "0" );
//		table.setAttribute( "cellpadding" , "0" );
//		table.setAttribute( "border" , "1" );
	}
	var tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
	var	tr = tbody.appendChild( m_Doc.createElement( "tr" ) );

	//タブの追加
	var	tab_off;
	for( tab_off = 0 ; tab_off < tab_num ; tab_off++ )
	{
		AppendTD_IMG( tr , tv.m_ImgFolder + "/Empty.png" );
	}
	// ハンドルの追加
	{
		if( m_Self.m_Children.length == 0 )
			AppendTD_IMG( tr , tv.m_ImgFolder + "/Empty.png" );
		else
		{
			var img = AppendTD_IMG( tr , m_Self.m_Open == true ? ( tv.m_ImgFolder + "/HandleOpen.png" ) : ( tv.m_ImgFolder + "/HandleClose.png" ) );
			img.onclick = new CallbackAdapt( m_Self.OnHandleClick ).exec;
		}
	}
	// アイコンの追加
	{
		AppendTD_IMG( tr , m_Self.m_Open == true ? ( tv.m_ImgFolder + "/" + m_Self.m_IconId + "_open.png" ) : ( tv.m_ImgFolder + "/" + m_Self.m_IconId + "_close.png" ) );
	}
	// HTMLの追加
	{
		var	td = tr.appendChild( m_Doc.createElement( "td" ) );
		{
//			td.setAttribute( "width" , "1%" );
			td.appendChild( m_Doc.createTextNode( m_Self.m_Title ) );
			td.setAttribute( "id" , m_Self.m_Id + "_select" );
			td.style.cursor='pointer';
			td.style.padding	= "0px 5px 0px 5px";
			
			if( m_Self == m_TV.m_Select )
			{
				td.style.backgroundColor	= m_SelectBackColor;//setAttribute( "bgcolor" , m_SelectBackColor );
				td.style.border = "1px solid " + m_SelectFrameColor;
			}
			else
				td.style.border = "1px solid #FFFFFF";
			td.onclick = new CallbackAdapt( m_Self.OnItemClick ).exec;
		}
	}
  	//子供がある場合は子供を追加する
	if( m_Self.m_Open == true )
	{
		var		c_off , c_num = m_Self.m_Children.length;
		for( c_off = 0 ; c_off < c_num ; c_off++ )
		{
			m_Self.m_Children[ c_off ].GetItemDOM( m_Doc , root , tab_num + 1 , tv );
		}
	}
}
// public function
//=======================================================================
//!	アイテムのDOMの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.GetItemDOM = function 
		(
		doc , 
		parent , 			//!< [in] 親
		tab_num ,  			//!< [in] タブ数
		tv
		)
{
	m_Doc		= doc;
	var	root	= parent.appendChild( m_Doc.createElement( "span" ) );
	{
		root.setAttribute( "id" , m_Self.m_Id );
	}
	GetItemDOM_root( root , tab_num , tv );
}
//=======================================================================
//!	set select
//!	@retval			---
//-----------------------------------------------------------------------
this.SetSelect = function
		(
		sw
		)
{
	var	td = m_Doc.getElementById( m_Self.m_Id + "_select" );
	if( td == null )
		return;
	if( sw == true )
	{
		td.style.backgroundColor	= m_SelectBackColor;
		td.style.border = "1px solid " + m_SelectFrameColor;
	}
	else
	{
		td.style.backgroundColor	= "#FFFFFF";
		td.style.border = "1px solid #FFFFFF";
	}
}
//=======================================================================
//!	アイテム以下を更新する
//!	@retval			---
//-----------------------------------------------------------------------
this.Update = function()
{
	if( m_Doc == null )
		return;
	var		root = m_Doc.getElementById( m_Self.m_Id );
	if( root == null )
		return;
	RemoveChildAll( root );
	GetItemDOM_root( root , m_Tab_num , m_TV ); 
}
//=======================================================================
//!	兄弟に同じ名前がある場合は名前を変える
//!	@retval			---
//-----------------------------------------------------------------------
/*
this.UpdateTitle = function()
{
	var		parent	= m_Self.m_Parent;
	if( parent == null )
		return;
	
	var		count = 0;	
	while( 1 )
	{
		var		off ,  num = parent.m_Children.length;
		for( off = 0 ; off < num ; off++ )
		{
			if( parent.m_Children[ off ] != m_Self )
			{
				if( parent.m_Children[ off ].m_Title == ( m_Self.m_Title + ( ( count==0 ) ? "" : ( "_"+count ) ) ) )
				{
					break;
				}
			}
		}
		if( off == num )
		{
			m_Self.m_Title	= m_Self.m_Title + ( ( count==0 ) ? "" : ( "_"+count ) );
			return;
		}
		count++;
	}
}
*/
//=======================================================================
//!	search uuid
//!	@retval			---
//-----------------------------------------------------------------------
this.SearchUUID = function
		(
		uuid
		)
{
	if( m_Self.m_UUID == uuid )
		return m_Self;
	
	var		off , num = m_Self.m_Children.length;
	for( off = 0 ; off < num ; off++ )
	{
		var	it = m_Self.m_Children[ off ].SearchUUID( uuid );
		if( it != null )
			return it;
	}
	return null;
}
//=======================================================================
//!	アイテムの数を数える
//!	@retval			---
//-----------------------------------------------------------------------
this.CountItemnum = function()
{
	var		count = 1;
	var		off , num = m_Self.m_Children.length;
	for( off = 0 ; off < num ; off++ )
	{
		count += m_Self.m_Children[ off ].CountItemnum();
	}
	return count;
}
}


/****************************************************************************
"TreePanel" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function TreePanel
		(
		img_folder
		)
{
	// イベント
	this.onexpand		= null;
	this.onpreselect	= null;
	this.onselect		= null;
	
	// メンバ変数
	this.m_ImgFolder			= img_folder;
	this.m_Select				= null;
	
	var		m_Self		= this;
	var 	m_Root 		= new TreePanelItem();
	var 	m_Id		= "TreePanel_" + GetUniqueId();
	var		m_Doc		= null;
	
// private function define
//=======================================================================
//!	アイテムの設定
//!	@retval			---
//-----------------------------------------------------------------------
function SetItem
		(
		tgt_item , 
		src_item
		)
{
	if( src_item.length != 5 )
		return false;

	tgt_item.m_Title 	= src_item[ 0 ];
	tgt_item.m_IconId	= src_item[ 1 ];
	tgt_item.m_Open		= src_item[ 2 ];
	tgt_item.m_UUID		= src_item[ 3 ];
	
	var		off , len = src_item[ 4 ] == null ? 0 : src_item[ 4 ].length;
	tgt_item.m_Children	= new Array( len );
	for( off = 0 ; off < len ; off++ )
	{
		var	it = new TreePanelItem();
		tgt_item.m_Children[ off ] = it;
		it.m_Parent	= tgt_item;
		
		if( src_item[ 4 ][ off ] != null )
		{
			if( false == SetItem( it  , src_item[ 4 ][ off ] ) )
				return false;
		}
	}
	
	return true;
}
// event functions define
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.OnHandleClick = function
		(
		args
		)
{
}

// private functions define
//=======================================================================
//!	アイテム以下を更新
//!	@retval			---
//-----------------------------------------------------------------------
function UpdateItem
		(
		it
		)
{
	var		root = m_Doc.getElementById( it.m_Id );
	
	RemoveChildAll( root );
	if( root == null )
		alert( "aa" );
	it.GetItemDOM_root( root , m_Tab_num , m_TV ); 
}
// functions define
//=======================================================================
//!	アイテムを設定する
//!	@retval			---
//-----------------------------------------------------------------------
this.SetItems = function
		(
		itemtree			//!< [in] 設定するアイテムツリー
		)
{
	if( false == SetItem( m_Root , itemtree ) )
		return false;
	m_Root.Update();
	return true;
}	
/*==================================================
DOMの獲得
		return   ---
---------------------------------------------------*/
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc		= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	m_Root.GetItemDOM( m_Doc , root , 0 , m_Self );
	
	return root;
}
//=======================================================================
//!	表示の更新
//!	@retval			---
//-----------------------------------------------------------------------
this.UpdateAll = function()
{
	m_Root.Update();
}
//=======================================================================
//!	アイテム数の獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.GetItemnum = function()
{
	return m_Root.CountItemnum();
}
//=======================================================================
//!	new
//!	@retval			---
//-----------------------------------------------------------------------
this.NewItem = function
		(
		title , 
		iconid
		)
{
	var	parent;
	if( m_Self.m_Select == null )
		parent	 = m_Root;
	else
		parent	= m_Self.m_Select;
	
	parent.m_Open = true;
	var	it = new TreePanelItem();
	parent.m_Children.push( it );
	it.m_Parent	= parent;
	it.m_Title	= title;
	it.m_IconId	= iconid;
	
	//選択の更新
	m_Self.m_Select	= it;
//	it.OnItemClick( null );
	
	//表示の更新
	parent.Update();
	
	return it;
}
//=======================================================================
//!	move up
//!	@retval			---
//-----------------------------------------------------------------------
this.Moveup = function()
{
	if( m_Self.m_Select == null )
		return;
	var parent	= m_Self.m_Select.m_Parent;
	if( parent == null )
		return null;
	
	//位置を検索
	var		off , num = parent.m_Children.length;
	for( off = 0 ; off < num ; off++ )
	{
		if( parent.m_Children[ off ] == m_Self.m_Select )
			break;
	}
	if( off == 0 )
		return null;
	//交換
	{
		var	temp = parent.m_Children[ off ];
		parent.m_Children[ off ] = parent.m_Children[ off - 1 ];
		parent.m_Children[ off - 1 ] = temp;
	}
	//更新
	parent.Update();
	
	return m_Self.m_Select;
}
//=======================================================================
//!	move down
//!	@retval			---
//-----------------------------------------------------------------------
this.Movedown = function()
{
	if( m_Self.m_Select == null )
		return;
	var parent	= m_Self.m_Select.m_Parent;
	if( parent == null )
		return null;
	
	//位置を検索
	var		off , num = parent.m_Children.length;
	for( off = 0 ; off < num ; off++ )
	{
		if( parent.m_Children[ off ] == m_Self.m_Select )
			break;
	}
	if( off == num - 1 )
		return null;
	//交換
	{
		var	temp = parent.m_Children[ off ];
		parent.m_Children[ off ] = parent.m_Children[ off + 1 ];
		parent.m_Children[ off + 1 ] = temp;
	}
	//更新
	parent.Update();
	
	return m_Self.m_Select;
}
//=======================================================================
//!	level down
//!	@retval			---
//-----------------------------------------------------------------------
this.Leveldown = function()
{
	if( m_Self.m_Select == null )
		return null;
	var parent	= m_Self.m_Select.m_Parent;
	if( parent == null )
		return;
	var g_parent	= parent.m_Parent;
	if( g_parent == null )
		return null;
		
	//位置を検索
	var		off , num = parent.m_Children.length;
	var		cnt = 0 , ary	= new Array( num - 1 );
	for( off = 0 ; off < num ; off++ )
	{
		if( parent.m_Children[ off ] != m_Self.m_Select )
		{
			ary[ cnt ]	= parent.m_Children[ off ];
			cnt++;
		}
	}
	parent.m_Children	= ary;
	
	// 追加する
	g_parent.m_Children.push( m_Self.m_Select );
	m_Self.m_Select.m_Parent	= g_parent;
	if( g_parent.m_Open == false )
		g_parent.m_Open	= true;
		
	//表示の更新
	g_parent.Update();
	
	return m_Self.m_Select;
}
//=======================================================================
//!	level up
//!	@retval			---
//-----------------------------------------------------------------------
this.Levelup = function()
{
	if( m_Self.m_Select == null )
		return null;
	var parent	= m_Self.m_Select.m_Parent;
	if( parent == null )
		return null;
	
	//位置を検索
	var		off , num = parent.m_Children.length;
	var		cnt = 0 , ary	= new Array( num - 1 );
	var		new_parent	= null;
	for( off = 0 ; off < num ; off++ )
	{
		if( parent.m_Children[ off ] != m_Self.m_Select )
		{
			ary[ cnt ]	= parent.m_Children[ off ];
			cnt++;
		}
		else
		{
			if( off == 0 )
				return;
			new_parent	= parent.m_Children[ off - 1 ];
		}
	}
	parent.m_Children	= ary;

	// 追加する
	new_parent.m_Children.push( m_Self.m_Select );
	m_Self.m_Select.m_Parent	= new_parent;
	if( new_parent.m_Open == false )
		new_parent.m_Open	= true;

	//更新
	parent.Update();

	return m_Self.m_Select;
}
//=======================================================================
//!	削除する
//!	@retval			---
//-----------------------------------------------------------------------
this.DeleteItem = function()
{
	if( m_Self.m_Select == null )
		return null;
	var parent	= m_Self.m_Select.m_Parent;
	if( parent == null )
		return null;

	var		uuid = m_Self.m_Select.m_UUID;
	
	//位置を検索
	var		off , num = parent.m_Children.length;
	var		cnt = 0 , ary	= new Array( num - 1 );
	for( off = 0 ; off < num ; off++ )
	{
		if( parent.m_Children[ off ] != m_Self.m_Select )
		{
			ary[ cnt ]	= parent.m_Children[ off ];
			cnt++;
		}
	}
	parent.m_Children	= ary;
	
	m_Self.m_Select = null;
	
	//更新
	parent.Update();
	
	return uuid;
}
//=======================================================================
//!	get select iconid
//!	@retval			---
//-----------------------------------------------------------------------
this.GetSelectItemIconId = function()
{
	if( m_Self.m_Select == null )
		return null;
	if( m_Self.m_Select == m_Root )
		return null;
	return m_Self.m_Select.m_IconId;
}
//=======================================================================
//!	get select title
//!	@retval			---
//-----------------------------------------------------------------------
this.GetSelectItemTitle = function()
{
	if( m_Self.m_Select == null )
		return null;
	if( m_Self.m_Select == m_Root )
		return null;
	return m_Self.m_Select.m_Title;
}
//=======================================================================
//!	set selected item info
//!	@retval			---
//-----------------------------------------------------------------------
this.SetSelctItemInfo = function
		(
		iconid , 
		title
		)
{
	if( m_Self.m_Select == null )
		return null;
	if( m_Self.m_Select == m_Root )
		return null;
	m_Self.m_Select.m_IconId	= iconid;
	m_Self.m_Select.m_Title	= title;
	m_Self.m_Select.Update();
	
	return m_Self.m_Select;
}
//=======================================================================
//!	選択の獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.GetSelect = function()
{
	return m_Self.m_Select;
}
//=======================================================================
//!	ドキュメントの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetDocument = function
		(
		uuid , 
		doc
		)
{
	it	= m_Root.SearchUUID( uuid );
	if( it == null )
		return false;
	it.m_Html	= doc;
	if( it == m_Self.m_Select )
		return true;
	return false;	
}
}


