﻿/****************************************************************************/
/*!
   	@file		TreeView.js
 	
	@author 	Fanzo
 	@date 		2007/7/8
*/
/****************************************************************************/


/****************************************************************************
"TreeViewItem" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function TreeViewItem()
{
	this.m_View		= null;
	this.m_Folder	= true;
	this.m_Open		= false;
	this.m_Children	= new Array( 0 );
	var		m_Self	= this;
	var		m_Id	= "TreeViewItem_" + GetUniqueId();

	var		m_Tab_num	= 0;
	var		m_TV		= null;

	var		m_Doc		= null;
	
// event functions define
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.OnHandleClick = function
		(
		args
		)
{
	m_Self.m_Open = m_Self.m_Open == true ? false : true;
	var		root = m_Doc.getElementById( m_Id );
	
	RemoveChildAll( root );

	GetItemDOM_root( root , m_Tab_num , m_TV ); 
}
// private function define
//=======================================================================
//!	td imgの追加
//!	@retval			---
//-----------------------------------------------------------------------
function AppendTD_IMG
		(
		parent , 
		img_path
		)
{
	var	td = parent.appendChild( m_Doc.createElement( "td" ) );
	{
//			td.setAttribute( "width" , "1%" );
	}
	var	img = td.appendChild( m_Doc.createElement( "img" ) );
	{
		img.setAttribute( "src" , img_path );
	}
	return img;
}
// public functions define
//=======================================================================
//!	root以下のアイテムの獲得
//!	@retval			---
//-----------------------------------------------------------------------
function GetItemDOM_root 
		(
		root ,  
		tab_num ,  			//!< [in] タブ数
		tv 
		)
{
	//保存
	m_Tab_num	= tab_num;
	m_TV		= tv;

	//アイテムのDOMの作成
	var	table	= root.appendChild( m_Doc.createElement( "table" ) );
	{
		table.setAttribute( "cellspacing" , "0" );
//		table.setAttribute( "border" , "1" );
	}
	var tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
	var	tr = tbody.appendChild( m_Doc.createElement( "tr" ) );

	//タブの追加
	var	tab_off;
	for( tab_off = 0 ; tab_off < tab_num ; tab_off++ )
	{
		AppendTD_IMG( tr , tv.m_EmptyImagePath );
	}
	// ハンドルの追加
	{
		if( m_Self.m_Children.length == 0 )
			AppendTD_IMG( tr , tv.m_EmptyImagePath );
		else
		{
			var img = AppendTD_IMG( tr , m_Self.m_Open == true ? tv.m_OpenHandleImagePath : tv.m_CloseHandleImagePath );
			img.onclick = new CallbackAdapt( m_Self.OnHandleClick ).exec;
		}
	}
	// アイコンの追加
	{
		if( m_Self.m_Folder == false )
			AppendTD_IMG( tr , tv.m_FileImagePath );
		else
			AppendTD_IMG( tr , m_Self.m_Open == true ? tv.m_OpenFolderImagePath : tv.m_CloseFolderImagePath );
	}
	// HTMLの追加
	{
		var	td = tr.appendChild( m_Doc.createElement( "td" ) );
		{
//			td.setAttribute( "width" , "1%" );
		}
		if( m_Self.m_View != null )
		{
			td.appendChild( m_Self.m_View.CreateDOM() );
		}
	}
  	//子供がある場合は子供を追加する
	if( m_Self.m_Open == true )
	{
		var		c_off , c_num = m_Self.m_Children.length;
		for( c_off = 0 ; c_off < c_num ; c_off++ )
		{
			m_Self.m_Children[ c_off ].GetItemDOM( m_Doc , root , tab_num + 1 , tv );
		}
	}
}
//=======================================================================
//!	アイテムのDOMの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.GetItemDOM = function 
		(
		doc , 
		parent , 			//!< [in] 親
		tab_num ,  			//!< [in] タブ数
		tv
		)
{
	m_Doc		= doc;
	var	root	= parent.appendChild( m_Doc.createElement( "span" ) );
	{
		root.setAttribute( "id" , m_Id );
	}
	GetItemDOM_root( root , tab_num , tv );
}
//=======================================================================
//!	SaveCookie
//!	@retval			---
//-----------------------------------------------------------------------
this.SaveCookie = function
		(
		name , 
		day
		)
{
	//状態のセーブ
	if( this.m_Open == true )
		SetCookie( name , "true" , day );
	else
		SetCookie( name , "false" , day );

	// コンテンツのセーブ
	if( this.m_View != null && this.m_View.SaveCookie != null )
	{
		this.m_View.SaveCookie( tag + "_content" , day );
	} 
	
	//子供のセーブ
	var	off , num = m_Self.m_Children.length;
	for( off = 0 ; off < num ; off++ )
	{
		var		tag = name + "_" + off;
		m_Self.m_Children[ off ].SaveCookie( tag , day );
	}
}
//=======================================================================
//!	LoadCookie
//!	@retval			---
//-----------------------------------------------------------------------
this.LoadCookie = function
		(
		name
		)
{
	//状態のロード
	var		val = GetCookie( name );
	if( val != null )
	{
		if( val == "true" )
			this.m_Open = true;
		else if( val == "false" )
			this.m_Open = false;
	}

	// コンテンツのロード
	if( this.m_View != null && this.m_View.LoadCookie != null )
	{
		this.m_View.LoadCookie( tag + "_content" );
	} 
	//子供のロード
	var	off , num = m_Self.m_Children.length;
	for( off = 0 ; off < num ; off++ )
	{
		var		tag = name + "_" + off;
		m_Self.m_Children[ off ].LoadCookie( tag );
	}
}

}


/****************************************************************************
"TreeView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function TreeView
		(
		open_handle , 		//!< [in] ハンドルが開いている画像のパス
		close_handle , 		//!< [in] ハンドルが閉じている画像のパス
		open_folder , 		//!< [in] フォルダが開いている画像のパス
		close_folder , 		//!< [in] フォルダが閉じている画像のパス
		file_image , 		//!< [in] ファイル画像のパス
		empty_image			//!< [in] 空画像のパス
		)
{
	// メンバ変数
	this.m_OpenHandleImagePath	= open_handle;
	this.m_CloseHandleImagePath	= close_handle;
	this.m_OpenFolderImagePath	= open_folder;
	this.m_CloseFolderImagePath	= close_folder;
	this.m_FileImagePath		= file_image;
	this.m_EmptyImagePath		= empty_image;
	
	var		m_Self		= this;
	var 	m_Root 		= new TreeViewItem();
	var 	m_Id		= "TreeView_" + GetUniqueId();
	var		m_Doc		= null;
	
// private function define
//=======================================================================
//!	アイテムの設定
//!	@retval			---
//-----------------------------------------------------------------------
function SetItem
		(
		tgt_item , 
		src_item
		)
{
	if( src_item.length != 4 )
		return false;

	tgt_item.m_View 	= src_item[ 0 ];
	tgt_item.m_Folder	= src_item[ 1 ];
	tgt_item.m_Open		= src_item[ 2 ];
	
	var		off , len = src_item[ 3 ].length;
	tgt_item.m_Children	= new Array( len );
	for( off = 0 ; off < len ; off++ )
	{
		var	it = new TreeViewItem();
		tgt_item.m_Children[ off ] = it;
		
		if( src_item[ 3 ][ off ] != null )
		{
			if( false == SetItem( it  , src_item[ 3 ][ off ] ) )
				return false;
		}
	}
	
	return true;
}
// event functions define
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.OnHandleClick = function
		(
		args
		)
{
}

// functions define
//=======================================================================
//!	アイテムを設定する
//!	@retval			---
//-----------------------------------------------------------------------
this.SetItems = function
		(
		itemtree			//!< [in] 設定するアイテムツリー
		)
{
	if( false == SetItem( m_Root , itemtree ) )
		return false;
	return true;
}	
/*==================================================
DOMの獲得
		return   ---
---------------------------------------------------*/
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc		= doc;
	
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	m_Root.GetItemDOM( m_Doc , root , 0 , m_Self );
	
	return root;
}
//=======================================================================
//!	SaveCookie
//!	@retval			---
//-----------------------------------------------------------------------
this.SaveCookie = function
		(
		name , 
		day
		)
{
	m_Root.SaveCookie( name , day );
}
//=======================================================================
//!	LoadCookie
//!	@retval			---
//-----------------------------------------------------------------------
this.LoadCookie = function
		(
		name
		)
{
	m_Root.LoadCookie( name );
}

}


