﻿/****************************************************************************/
/*!
   	@file		WebNote.js
	@author 	Fanzo
 	@date 		2007/7/30
*/
/****************************************************************************/

/****************************************************************************
"WebNote" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function WebNote
		(
		img_folder , 
		php_path
		)
{
//=======================================================================
//!	new
//!	@retval			---
//-----------------------------------------------------------------------
this.OnNew = function
		(
		parentid , 
		offset , 
		id , 
		title , 
		doc , 
		icon , 
		handle
		)
{
	m_Storage.New( parentid , offset , id , title , doc , icon , handle );
}
//=======================================================================
//!	expand
//!	@retval			---
//-----------------------------------------------------------------------
this.OnExpand = function
		(
		uuid , 
		handle
		)
{
	m_Storage.Update( uuid , null , null , null , ( handle == true ) ? 1 : 0 );
}
//=======================================================================
//!	editinfo
//!	@retval			---
//-----------------------------------------------------------------------
this.OnEditInfo = function
		(
		uuid , 
		title , 
		icon
		)
{
	m_Storage.Update( uuid , title , null , icon , null );
}
//=======================================================================
//!	move
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMove = function
		(
		id , 
		parentid ,
		offset
		)
{
	m_Storage.Move( id , parentid , offset );
}
//=======================================================================
//!	delete
//!	@retval			---
//-----------------------------------------------------------------------
this.OnDelete = function
		(
		uuid
		)
{
	m_Storage.Delete( uuid );
}
//=======================================================================
//!	updatedocument
//!	@retval			---
//-----------------------------------------------------------------------
this.OnUpdateDocument = function
		(
		uuid , 
		html
		)
{
	m_Storage.Update( uuid , null , html , null , null );
}
//=======================================================================
//!	unload
//!	@retval			---
//-----------------------------------------------------------------------
this.OnUnload = function
		(
		uuid , 
		html
		)
{
	m_Storage.Update( uuid , null , html , null , null , false );
}
//=======================================================================
//!	need document
//!	@retval			---
//-----------------------------------------------------------------------
this.OnNeedDocument = function
		(
		uuid
		)
{
	m_Storage.GetDocument( uuid );
}
//=======================================================================
//!	new
//!	@retval			---
//-----------------------------------------------------------------------
this.OnNewReqest	= function()
{
}
//=======================================================================
//!	update
//!	@retval			---
//-----------------------------------------------------------------------
this.OnUpdateReqest	= function()
{
}
//=======================================================================
//!	delete
//!	@retval			---
//-----------------------------------------------------------------------
this.OnDeleteReqest	= function()
{
}
//=======================================================================
//!	gettree
//!	@retval			---
//-----------------------------------------------------------------------
this.OnGetTreeReqest	= function
		(
		treeitem
		)
{
	m_Editor.SetTree( treeitem );
	m_Msg.EndMessageDlg();
}
//=======================================================================
//!	get document
//!	@retval			---
//-----------------------------------------------------------------------
this.OnGetDocumentReqest	= function
		(
		uuid , 
		doc
		)
{
	if( uuid != null )
		m_Editor.SetDocument( uuid , doc );
}
//=======================================================================
//!	move
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMoveReqest	= function()
{
}
//=======================================================================
//!	error
//!	@retval			---
//-----------------------------------------------------------------------
this.OnErrorReqest	= function
		(
		it
		)
{
	if( it.m_Cmd == "gettree" )
	{
		m_Msg.EndMessageDlg();
		m_Msg.MessageDlg( "エラー" , "データのダウンロードに失敗しました。" , ERROR_ICON );
	}
//	alert( "error" );
}

	var		m_Editor			= new TreeEditor( img_folder );
	{
		m_Editor.onnew				= this.OnNew;
		m_Editor.onexpand			= this.OnExpand;
		m_Editor.ondelete			= this.OnDelete;
		m_Editor.onupdatedocument	= this.OnUpdateDocument;
		m_Editor.onneeddocument		= this.OnNeedDocument;
		m_Editor.oneditinfo			= this.OnEditInfo;
		m_Editor.onmove				= this.OnMove;
		m_Editor.onunload			= this.OnUnload;
	}
	var		m_Storage			= new Storage( php_path );
	{
		m_Storage.onnew			= this.OnNewReqest;
		m_Storage.onupdate		= this.OnUpdateReqest;
		m_Storage.ondelete		= this.OnDeleteReqest;
		m_Storage.ongettree		= this.OnGetTreeReqest;
		m_Storage.ongetdocument	= this.OnGetDocumentReqest;
		m_Storage.onmove		= this.OnMoveRequest;
		m_Storage.onerror		= this.OnErrorReqest;
	}	
	var		m_Msg		= new MessageDlg
			(
			img_folder + "/MsgBox" , 
			img_folder + "/Shadow"
			);
	var		m_Self				= this;
	var 	m_Id				= "WebNote_" + GetUniqueId();
	var		m_Doc				= null;
	
// private function define

// public functions define
//=======================================================================
//!	load
//!	@retval			---
//-----------------------------------------------------------------------
this.Load = function()
{
	m_Msg.MessageDlg( "メッセージ" , "データをダウンロードしています。" , 0 );
	m_Storage.GetTree();
}
//=======================================================================
//!	Unload
//!	@retval			---
//-----------------------------------------------------------------------
this.Unload	= function()
{
	m_Editor.Unload();
	if( true == m_Storage.IsQueExist() )
		return false;
	return true;
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc	= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );
	root.appendChild( m_Editor.CreateDOM( m_Doc ) );
	
	return root;
}

}
